package com.mile.v4_navigation_engine.Navigation.model

import com.google.gson.Gson
import com.google.gson.internal.LinkedTreeMap
import com.mile.v4_navigation_engine.model.LanguageCode

data class SmartFact(
        var arrayDescription : Map<LanguageCode, String>?,
        val cities: List<String>?,
        val status : Long?
) {

    companion object{
        val DESCRIPTION_FIELD = "Description";
        val ID_CITY_FIELD = "IdCity";
        val STATUS_FIELD = "Status";

        fun fromFlutter(data: LinkedTreeMap<*,*>): SmartFact {
            
            val arrayDescription = HashMap<LanguageCode, String>()
            if(data[SmartFact.DESCRIPTION_FIELD] != null) {
                var dataName = data[SmartFact.DESCRIPTION_FIELD] as LinkedTreeMap<String, String>?
                dataName?.forEach { name ->
                    arrayDescription[LanguageCode.getLanguageCodeFrom(name.key)] = name.value
                }
            }

            var arrayCities = ArrayList<String>()
            //var listCitiesSnapshots: HashMap<String, Boolean>?
            if(data[SmartFact.ID_CITY_FIELD] != null){
                arrayCities = data[SmartFact.ID_CITY_FIELD] as ArrayList<String>
            }

            var status = 0L
            if(data.containsKey(STATUS_FIELD))
                status = (data[STATUS_FIELD] as Double).toLong()

            var smartFact = SmartFact(arrayDescription, arrayCities, status)
            return smartFact
        }
    }
}