package com.mile.v4_navigation_engine.model

import android.location.Location
import com.google.gson.Gson
import com.google.gson.internal.LinkedTreeMap
import com.mile.v4_navigation_engine.Navigation.ApplicationRunner
import com.mile.v4_navigation_engine.Navigation.model.Riddle
import com.mile.v4_navigation_engine.R

data class SportSession(
        val id : String?,
        var arrayCoordinates : List<Location>,
        val radius: Long
){

    var isSeen = false;
    companion object {
        val ID_FIELD = "id"
        val COORDINATES_FIELD = "GPS"
        val RANGE_FIELD = "Range"

        fun fromFlutter(data: LinkedTreeMap<*,*>): SportSession {
            //System.out.println(jsonPOI);
            //val data: Map<*, *> = Gson().fromJson(jsonPOI, MutableMap::class.java)

            var id = ""
            if(data.containsKey(ID_FIELD))
                id = data[ID_FIELD] as String

            var range = 0L
            if(data.containsKey(RANGE_FIELD))
                range = (data[RANGE_FIELD] as Double).toLong()

            val arrayCoordinates = ArrayList<Location>()
            val listCoordinatesSnapshot = data[COORDINATES_FIELD] as ArrayList<LinkedTreeMap<String, Double>>
            listCoordinatesSnapshot.forEach {
                var location = Location("provider")
                it.forEach {
                    if(it.key == "Latitude" || it.key == "latitude")
                        location.latitude = it.value
                    if(it.key == "Longitude" || it.key == "longitude")
                        location.longitude = it.value
                }
                arrayCoordinates.add(location)
            }

            return SportSession(id, arrayCoordinates, range)
        }

    }
}


