package com.mile.v4_navigation_engine.Navigation.model

import com.google.gson.Gson

data class WhiteLabel(
        val isWhiteLabel : Boolean?,
        val beginInstruction: String?,
        val endInstruction: String?
) {

    companion object{
        val IS_WHITE_LABEL_FIELD = "isWhiteLabel";
        val BEGIN_INSTRUCTION_FIELD = "beginInstruction";
        val END_INSTRUCTION_FIELD = "endInstruction";

        fun fromFlutter(json: String): WhiteLabel {

            System.out.println(json);
            val data: Map<*, *> = Gson().fromJson(json, MutableMap::class.java)

            var isWhiteLabel = true
            if(data.containsKey(IS_WHITE_LABEL_FIELD))
                isWhiteLabel = data[IS_WHITE_LABEL_FIELD] as Boolean
            
            var beginInstruction = ""
            if(data.containsKey(BEGIN_INSTRUCTION_FIELD))
                beginInstruction = data[BEGIN_INSTRUCTION_FIELD] as String
            
            var endInstruction = ""
            if(data.containsKey(END_INSTRUCTION_FIELD))
                endInstruction = data[END_INSTRUCTION_FIELD] as String
            
            var whiteLabel = WhiteLabel(isWhiteLabel, beginInstruction, endInstruction)
            return whiteLabel
        }
    }
}
