package com.mile.v4_navigation_engine.utils

import com.mile.v4_navigation_engine.Navigation.ApplicationRunner
import com.mile.v4_navigation_engine.model.LanguageCode

class LanguageResource(languageCode: LanguageCode?) {
    var endRoute = ""
    var inversionRoute = ""
    var routeReached = ""
    var startNavigationToPOI = ""
    var startNavigationToRoute = ""
    var wrongWay = ""
    var resumeNavigation = ""
    var pauseNavigation = ""
    var right = ""
    var left = ""
    var front = ""
    var continueStraight = ""
    private var uTurn = ""
    var moreInfo = ""
    var lowBattery = ""
    var turnLeft = ""
    var turnRight = ""
    var then = ""
    var onto = ""
    var toCrossTheRoad = ""
    var onDistanceMeters = ""
    var annonceSponsor = ""
    var and = ""
    var moreSponsorInformations = ""
    var infoPOINearby = ""
    var runStarted = ""
    var runTourismStarted = ""
    var offRoute = ""
    var congratulationsFinishRoute = ""
    var finishNavigation = ""
    var startNavigationToTreasureHunt = ""
    var treasureHuntDepartureReached = ""
    var pauseTreasureHunt = ""
    var resumeTreasureHunt = ""
    var congratulationsFinishTreasureHunt = ""
    var finishTreasureHunt = ""

    var navigationArrivedToRoutes = ""
    var wasteToTrash = ""
    var recalculated = ""

    fun getuTurn(): String {
        return uTurn
    }

    companion object {
        val languagesResources: LanguageResource
            get() = LanguageResource(ApplicationRunner.appLanguage)
    }

    init {
        when (languageCode) {
            LanguageCode.FR -> {
                endRoute = "Félicitations, vous avez fini votre parcours ! N'hésite pas à nous donner votre avis."
                inversionRoute = "Nous venons de modifier l'orientation du parcours."
                routeReached = "Vous avez atteint le parcours. Continuez tout droit."
                startNavigationToPOI = "Nous allons maintenant vous guider à pied vers le point d'intérêt."
                startNavigationToRoute = " Nous allons maintenant vous guider à pied vers le point le plus proche du parcours."
                startNavigationToTreasureHunt = "Nous allons maintenant vous guider vers le départ du jeu de piste."
                wrongWay = "Vous allez dans la mauvaise direction, faites demi tour."
                resumeNavigation = "Reprise du parcours"
                pauseNavigation = "Parcours en pause"
                resumeTreasureHunt = "Reprise du jeu de piste"
                pauseTreasureHunt = "Jeu de piste en pause"
                right = "À votre droite, "
                left = "À votre gauche, "
                front = "Face à vous, "
                continueStraight = "continuez tout droit "
                uTurn = "Faites demi-tour, puis "
                moreInfo = "+ d'infos"
                lowBattery = "Attention, le niveau de batterie de votre smartphone est faible."
                turnRight = "Tournez à droite "
                turnLeft = "Tournez à gauche "
                toCrossTheRoad = "pour traverser la route,"
                then = " puis " //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
                onto = " sur "
                onDistanceMeters = "sur %1\$s mètres"
                annonceSponsor = "Ce parcours vous est offert par "
                and = ", et, "
                moreSponsorInformations = ". Pour plus d'informations, cliquez sur les marqueurs rouges."
                infoPOINearby = "Vous êtes à proximité d'un point d'intérêt. Pour lire sa description, rendez-vous sur l'application."
                runStarted = "Le parcours a démarré. Profitez bien !"
                runTourismStarted = "Le parcours a démarré. Bonne visite !"
                offRoute = "Vous êtes sorti du parcours, merci de faire demi-tour"
                congratulationsFinishRoute = "Félicitations, vous avez terminé le parcours. Nous espérons que vous avez apprécié votre expérience."
                finishNavigation = "Parcours terminé. Nous espérons que vous avez apprécié votre expérience."
                finishTreasureHunt = "Jeu de piste terminé. Nous espérons que vous avez apprécié votre expérience avec Sur les chemins de Miramas ."
                treasureHuntDepartureReached = "Vous êtes arrivé à la première étape du jeu de piste. Que la chasse commence !"
                congratulationsFinishTreasureHunt = "Félicitations, vous avez terminé le jeu de piste!"
                wasteToTrash = " Si vous voulez aider un peu la planète, vous pouvez ramasser 3 ordures sur votre trajet et les jeter dans une poubelle."
                recalculated = "L'itinéraire a été recalculé."
                navigationArrivedToRoutes = "Vous êtes arrivé sur le parcours "
            }
            LanguageCode.EN -> {
                endRoute = "Congratulations, you have reached the end of this route! Please feel free to give us a feedback."
                inversionRoute = "We have changed the direction of the route"
                routeReached = "You have reached the route please carry straight on."
                startNavigationToPOI = "We will now guide you to your point of interest."
                startNavigationToRoute = "We will now guide you to the route."
                wrongWay = "You are running the wrong way, please make a u-turn."
                resumeNavigation = "Route resumed"
                pauseNavigation = "Route paused"
                right = "To your right, "
                left = "To your right, "
                front = "Straight ahead, "
                continueStraight = "carry straight on "
                uTurn = "Make a u-turn, then "
                moreInfo = "More info"
                lowBattery = "Warning, your smartphone battery level is low."
                then = " then " //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
                onto = " onto "
                turnRight = "Turn right" //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
                turnLeft = "Turn left" //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
                toCrossTheRoad = "to cross the road,"
                onDistanceMeters = "for %1\$s meters"
                annonceSponsor = "This route is brought to you by "
                and = ", and, "
                moreSponsorInformations = ". For more information, click on the red pin."
                infoPOINearby = "A point of interest is nearby. To read its description, check the app."
                runStarted = "Route started. Enjoy your experience !"
                offRoute = "You have left the designated route, check your phone to get back on track."
                congratulationsFinishRoute = "Congratulations, you have completed the route. We hope you have enjoyed your experience."
                finishNavigation = "Route ended. We hope you have enjoyed your experience."
                startNavigationToTreasureHunt = "We will guide you to the beginning of the treasure hunt."
                resumeTreasureHunt = "Treasure hunt resumed"
                pauseTreasureHunt = "Treasure hunt paused"
                finishTreasureHunt = "Treasure hunt ended. We hope you have enjoyed your experience with Sur les chemins de Miramas."
                treasureHuntDepartureReached = "Vous êtes arrivés à la première étape du jeu de piste, que la chasse commence !"
                wasteToTrash = " If you want to help the planet, you can pick up three pieces of trash and throw them in a trash can"
                congratulationsFinishTreasureHunt = "Congratulations, you have finished this treasure hunt!"
            }
            LanguageCode.NL -> {
                endRoute = "Gefeliciteerd, je hebt het einde van deze route bereikt! Voel je vrij om ons feedback te geven."
                inversionRoute = "We hebben de richting van de route veranderd"
                routeReached = "U heeft de route bereikt, ga rechtdoor."
                startNavigationToPOI = "We zullen u nu naar uw interessante plaats leiden."
                startNavigationToRoute = "We zullen je nu naar de route leiden."
                wrongWay = "U loopt de verkeerde kant op, maak een u-bocht."
                resumeNavigation = "Route hervat"
                pauseNavigation = "Route onderbroken"
                right = "Rechts van je, "
                left = "Links van je, "
                front = "Rechtdoor, "
                continueStraight = "ga rechtdoor "
                uTurn = "Maak dan een u-bocht, dan "
                moreInfo = "Meer informatie "
                lowBattery = "Waarschuwing, het batterijniveau van uw smartphone is laag. "
                then = " dan " //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
                onto = " op "
                turnRight = "Sla rechtsaf" //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
                turnLeft = "Sla linksaf" //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
                toCrossTheRoad = "de weg oversteken, "
                onDistanceMeters = "voor %1\$s meter"
                annonceSponsor = "Deze route wordt u aangeboden door "
                and = ", en, "
                moreSponsorInformations = ". Klik voor meer informatie op de rode pin."
                infoPOINearby = "Een bezienswaardigheid is vlakbij. Controleer de app om de beschrijving te lezen."
                runStarted = "Route begonnen. Geniet van je ervaring!"
                offRoute = "Je hebt de aangegeven route verlaten, controleer je telefoon om weer op het goede spoor te komen."
                congratulationsFinishRoute = "Gefeliciteerd, je hebt de route voltooid. We hopen dat je van je ervaring hebt genoten."
                finishNavigation = "Route beëindigd. We hopen dat je van je ervaring hebt genoten."
                startNavigationToTreasureHunt = "We begeleiden je naar het begin van de speurtocht."
                wasteToTrash = "Als je de planeet wilt helpen, kun je drie stukken afval oprapen en in een vuilnisbak gooien"
                congratulationsFinishTreasureHunt = "Congratulations, you have finished this treasure hunt!"
            }
            LanguageCode.IT -> {
                endRoute = "Congratulazioni, hai terminato il percorso! Condividi con noi una recensione!"
                inversionRoute = "Stiamo modificando il percorso"
                routeReached =  "Hai raggiunto il percorso. Prosegui dritto."
                startNavigationToPOI = "Ora ti portiamo verso il punto di interesse"
                startNavigationToRoute = "Ora ti portiamo verso il punto del percorso più vicino."
                startNavigationToTreasureHunt = "Ora ti portiamo verso il punto di inizio della caccia al tesoro."
                wrongWay = "Stai andando nella direzione sbagliata, torna indietro."
                resumeNavigation = "Riprendi il percorso "
                pauseNavigation =  "Percorso in pausa "
                resumeTreasureHunt = "Riprendi la caccia al tesoro "
                pauseTreasureHunt = "Caccia al tesoro in pausa "
                right = "Sulla tua destra "
                left = "Sulla tua sinistra "
                front =  "Di fronte a te "
                continueStraight = "Prosegui dritto "
                uTurn = "Torna indietro "
                moreInfo = "Più info"
                lowBattery = "Attenzione, il livello di batteria del tuo smartphone è basso"
                turnRight =  "Svolta a destra"
                turnLeft = "Svolta a sinistra"
                toCrossTheRoad = "Per attraversare la strada"
                then =  "Poi" //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
                onto = "su"
                onDistanceMeters =  "su %1\$s metri"
                annonceSponsor = "Questo percorso è sponsorizzato da "
                and = ", e,"
                moreSponsorInformations = "Per maggiori informazioni, clicca sull'indicatore rosso."
                infoPOINearby = "Sei vicino ad un punto di interesse. Per leggere la descrizione, vai sull'app."
                runStarted = "Il percorso sta iniziando. Buona corsa!"
                offRoute = "Sei uscito dal percorso, guarda sul tuo smartphone per riprendere la giusta direzione."
                congratulationsFinishRoute = "Congratulazioni, hai terminato il percorso. Ci auguriamo che ti sia piaciuta questa esperienza."
                finishNavigation =  "Percorso terminato. Ci auguriamo che ti sia piaciuta questa esperienza."
                finishTreasureHunt =  "Caccia al tesoro terminata. Ci auguriamo che ti sia piaciuta questa esperienza con Sui sentieri di Miramas."
                treasureHuntDepartureReached = "Sei arrivato alla prima tappa della caccia al tesoro. Che la caccia inizi!"
                wasteToTrash = " Se vuoi aiutare il pianeta, raccogli durante il percorso 3 rifiuti e gettali in un cestino."
                congratulationsFinishTreasureHunt = "Congratulazioni, hai terminato la caccia al tesoro!"
            }
            LanguageCode.DE -> {
                endRoute = "Glückwunsch, du hast den Parkour absolviert. Wir würden uns sehr  freuen, Feedback von Dir zu erhalten."
                inversionRoute = "Wir haben den Parkour nun bearbeitet."
                routeReached = "Du hast den Parkour beendet. Laufe weiter geradeaus."
                startNavigationToPOI = "Wir leiten dich nun zu Fuß zur nächsten Sehenswürdigkeit."
                startNavigationToRoute = "Wir leiten dich nun zu Fuß zu der nächstliegenden Sehenswürdigkeit des Parkoures."
                startNavigationToTreasureHunt = "Wir leiten dich nun zum Startpunkt der Schnitzeljadg."
                wrongWay = "Du bist in die falsche Richtung gelaufen. Drehe um und laufe in der anderen Richtung weiter."
                resumeNavigation = "Parkour aufgenommen"
                pauseNavigation = "Navigation pausiert"
                resumeTreasureHunt = "Schnitzeljagd wird fortgesetzt"
                pauseTreasureHunt = "Schnitzeljagd pausiert "
                right = "Nach rechts, "
                left = "Nach links, "
                front = "Gegenüber von dir "
                continueStraight = "Gehe weiter geradeaus "
                uTurn = "Drehe um, dann "
                moreInfo = "mehr Info"
                lowBattery = "Achtung, die Batterie deines Handys ist schwach."
                turnRight = "Biege rechts ab "
                turnLeft = "Biege links ab "
                toCrossTheRoad = "um die Straße zu überqueren"
                then = " dann" //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
                onto = " auf "
                onDistanceMeters = "für %1\$s Meter"
                annonceSponsor = "Dieser Parkour wurde gesponsert von "
                and = ", und "
                moreSponsorInformations = "Für mehr Informationen, klicke auf das rot markierte Feld."
                infoPOINearby = "Du bist in der Nähe einer Sehenswürdigkeit. Um die Beschreibung zu lesen, öffne die App."
                runStarted = "Der Parkour startet. Viel Spaß!"
                offRoute = "Du bist außerhalb der Strecke, schaue auf deinem Handy nach, um wieder in die richtige Richtung zu gelangen."
                congratulationsFinishRoute = "Glückwunsch, du hast den Parkour fertiggestellt. Wir hoffen, du hattest eine tolle Erfahrung."
                finishNavigation = "Parkour beendet. Wir hoffen, es war eine schöne Erfahrung."
                finishTreasureHunt = "Die Schnitzeljadg ist beendet. Wir hoffe, du hattest Spaß und eine schöne Erfahrung mit ,Sur les chemins de Miramas."
                treasureHuntDepartureReached = "Du bist am ersten Punkt der Schnitzeljagd angelangt. Möge die Jagd beginnen!"
                wasteToTrash = " Wenn Sie dem Planeten helfen möchten, können Sie mit einer kleinen Geste drei Stücke Müll einsammeln und im nächsten Müllkorb entsorgen."
                congratulationsFinishTreasureHunt = "Herzlichen Glückwunsch, du hast die Schnitzeljagd beendet."
            }
            LanguageCode.ES -> {
                endRoute = "¡Felicidades, has terminado tu ruta! No dudes en darnos tu opinión."
                inversionRoute = "Acabamos de cambiar la orientación de la ruta."
                routeReached = "Has llegado a la ruta. Continúa recto."
                startNavigationToPOI = "Ahora te guiaremos a pie al punto de interés."
                startNavigationToRoute = "Ahora te guiaremos a pie hasta el punto más cercano a la ruta."
                startNavigationToTreasureHunt = "Ahora te guiaremos al comienzo de la búsqueda del tesoro."
                wrongWay = "Estás yendo en la dirección equivocada, da media vuelta."
                resumeNavigation = "Reanudación de la ruta"
                pauseNavigation = "Ruta en pausa"
                resumeTreasureHunt = "Reanudación de la búsqueda del tesoro"
                pauseTreasureHunt = "Búsqueda del tesoro en pausa"
                right = "A tu derecha, "
                left = "A tu izquierda, "
                front = "Frente a ti, "
                continueStraight = "sigue recto "
                uTurn = "Da media vuelta, luego "
                moreInfo = "+ información"
                lowBattery = "Toma en cuenta que el nivel de batería de tu smartphone es bajo."
                turnRight = "Gira a la derecha "
                turnLeft = "Gira a la izquierda "
                toCrossTheRoad = "para cruzar la calle,"
                then = "luego" //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
                onto = " por "
                onDistanceMeters = "en %1\$s metros"
                annonceSponsor = "Esta ruta es ofrecida por "
                and = ", y, "
                moreSponsorInformations = ". Para obtener más información, haz clic en los marcadores rojos ."
                infoPOINearby = "Estás cerca de un punto de interés. Para leer su descripción, ve a la aplicación."
                runStarted = "La ruta ha comenzado. ¡Que tengas una buena carrera!"
                offRoute = "Has dejado la ruta, mira tu smartphone para retomar la dirección correcta."
                congratulationsFinishRoute = "Felicidades, has completado la ruta. Esperamos que hayas disfrutado tu experiencia."
                finishNavigation = "Ruta terminada. Esperamos que hayas disfrutado tu experiencia."
                finishTreasureHunt = "Búsqueda del tesoro terminada. Esperamos que hayas disfrutado tu experiencia con En los caminos de Miramas ."
                treasureHuntDepartureReached = "Has llegado a la primera etapa de la búsqueda del tesoro. ¡Que comience la caza!"
                wasteToTrash = " Si quieres ayudar un poco al planeta, puedes recoger 3 desechos en el camino y ponerlos en un basurero."
                congratulationsFinishTreasureHunt = "¡Felicidades, has terminado la búsqueda del tesoro!"
            }
            LanguageCode.PT -> {
                endRoute = "Parabéns, acabaste o teu percurso! Nao hesites em  nos dar a tua opiniao."
                inversionRoute = "Acabamos de modificar a orientaçao do percurso."
                routeReached = "Alcançaste o percurso. Continua em frente."
                startNavigationToPOI = "Nos vamos agora guiar-te a pé até ao ponto de interesse."
                startNavigationToRoute = "Nos vamos agora guiar-te a pé até ao ponto mais proximo do percurso."
                startNavigationToTreasureHunt = "Nos vamos agora guiar-te até ao inicio da caça ao tesouro."
                wrongWay = "Estas a ir na direçao errada, da meia volta."
                resumeNavigation = "De volta ao percurso"
                pauseNavigation = "Percurso em pausa"
                resumeTreasureHunt = "De volta à caça ao tesouro"
                pauseTreasureHunt = "Caça ao tesouro em pausa"
                right = "À tua direita, "
                left = "À tua esquerda, "
                front = "A tua frente, "
                continueStraight = "continua em frente "
                uTurn = "Da meia volta, depois "
                moreInfo = "+ informaçoes"
                lowBattery = "Atençao, o nivel de bateria do teu télémovel esta baixo."
                turnRight = "Vira à direita "
                turnLeft = "Vira à esquerda "
                toCrossTheRoad = "para atravessar a estrada,"
                then = " depois " //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
                onto = " em "
                onDistanceMeters = "em %1\$s metros"
                annonceSponsor = "Este percurso é te oferecido por"
                and = ", e , "
                moreSponsorInformations = ". Para mais informaçoes, clica nos marcadores vermelhos."
                infoPOINearby = "Estas proximo de um ponto de interesse. Para ler a sua descriçao, vai para a aplicaçao."
                runStarted = "O percurso começou. Boa corrida !"
                offRoute = "Saiste do percurso, olha para o teu télémovel para voltar para a direçao correta."
                congratulationsFinishRoute = "Prabéns, terminaste o percuro. Esperamos que tenhas gostado da tua experiência."
                finishNavigation = "Percurso terminado. Esperamos que tenhas gostado da tua experiência."
                finishTreasureHunt = "Caça ao tesouro terminada. Esperamos que tenhas gostado da tua experiência com Sur les chemins de Miramas."
                treasureHuntDepartureReached = "Chegaste à primeira étapa da caça ao tesouro. Que a caça começe !"
                wasteToTrash = " Se quer ajudar o planeta, você pode apanhar tês peças de lixo no seu trajeto e metê-las no caixote."
                congratulationsFinishTreasureHunt = "Parabéns, acabaste a caça ao tesouro!"
            }
        }
    }
}