
import 'package:flutter/material.dart';
import 'package:flutter/scheduler.dart';

class Modal {
  static show(BuildContext context, Image icon, String title, Image illustration, String message, String firstButtonText, VoidCallback firstButtonCallback, String secondButtonText, VoidCallback secondButtonCallback) {
    Dialog dialog = Dialog(
      shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(12.0)), //this right here
      child: Container(
        padding: EdgeInsets.symmetric(horizontal: 15),
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          mainAxisSize: MainAxisSize.min,
          children: <Widget>[
            icon != null ?
              Container(
                height: 28,
                width: 28,
                margin: EdgeInsets.only(top: 20),
                child: icon,
              ) : Container(),

            title != null ?
              Container(
                margin: EdgeInsets.only(top: 20),
                child: Center(
                  child: Text(
                    title,
                    textAlign: TextAlign.center,
                    style: TextStyle(
                      fontSize: 20,
                      fontWeight: FontWeight.w700,
                    ),
                  ),
                ),
              ) : Container(),

            illustration != null ?
              Container(
                height: 140,
                margin: EdgeInsets.only(top: 20),
                decoration: new BoxDecoration(
                  borderRadius: BorderRadius.circular(15),
                  image: new DecorationImage(
                    fit: BoxFit.fitHeight,
                    image: illustration.image,
                    ),
                  ),
                ) : Container(),

            message != null ?
              Container(
                padding: EdgeInsets.only(left: 20.0, right: 20.0),
                margin: EdgeInsets.only(top: 20),
                child: Center(
                  child: Text(
                    message,
                    textAlign: TextAlign.center,
                    style: TextStyle(
                      fontSize: 12,
                    ),
                  ),
                ),
              ) : Container(),

            InkWell(
                onTap: () {
                  Navigator.of(context).pop();
                  if(firstButtonCallback != null){
                    firstButtonCallback();
                  }
                },
                child: Container(
                  height: 56,
                  margin: EdgeInsets.only(top: 20),
                  child: Center(
                    child: Text(
                      firstButtonText,
                      style: TextStyle(
                        color: Colors.white,
                        fontSize: 16.0,
                        fontWeight: FontWeight.w700,
                      ),
                    ),
                  ),
                  decoration: BoxDecoration(
                    color: Colors.blue,
                    borderRadius: new BorderRadius.all(const Radius.circular(28.0)),
                    boxShadow: [BoxShadow(color: Color(0xFFDDDDDD), blurRadius: 3, offset: Offset(0.0, 0.0,),)],
                  ),
                )
            ),

            secondButtonText != null ?
              InkWell(
                  onTap: () {
                    Navigator.of(context).pop();
                    if(secondButtonCallback != null){
                      secondButtonCallback();
                    }
                  },
                  child: Container(
                    height: 44,
                    margin: EdgeInsets.only(top: 10),
                    child: Center(
                      child: Text(
                        secondButtonText,
                        style: TextStyle(
                          color: Colors.blue,
                          fontSize: 16.0,
                          fontWeight: FontWeight.w700,
                        ),
                      ),
                    ),
                  )
              ) : Container(),

            Container(height: 20,),
          ],
        ),
      ),
    );
    //SchedulerBinding.instance.addPostFrameCallback((_) => showDialog(context: context, builder: (BuildContext context) => dialog));
    showDialog(context: context, builder: (BuildContext context) => dialog);
}
}