import 'dart:io';

import 'package:flutter/material.dart';
import 'package:v4_navigation_engine/v4_navigation_lib.dart';

import 'about.dart';

class NavigationSportif extends StatefulWidget {

  static const routeName = '/navigation';

  String mode;

  NavigationSportif({Key key, this.mode}) : super(key: key);

  @override
  _NavigationSportifState createState() => _NavigationSportifState();
}


class _NavigationSportifState extends State<NavigationSportif> {

  bool navigationStarted = false;

  MileNavigationController navigationController;

  @override
  void initState(){
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return SafeArea(
      child: Scaffold(
        body: Stack(
          children: <Widget>[
            Container(
              height: MediaQuery.of(context).size.height,
              width: MediaQuery.of(context).size.width,
              child: NavigationView(
                route: '{"id":"PA19","idDestination":"V0","arrayName":{"EN":"Saint-Suspi Challenge","FR":"Défi de Saint-Suspi"},"arrayDescription":{"EN":" ","FR":" "},"arrayCoordinates":[{"latitude":43.588849,"longitude":5.010205000000013},{"latitude":43.588636,"longitude":5.013103000000001},{"latitude":43.588605,"longitude":5.013538000000011},{"latitude":43.589357,"longitude":5.013664000000006},{"latitude":43.590223,"longitude":5.01343700000001},{"latitude":43.590977,"longitude":5.013206999999994},{"latitude":43.590714,"longitude":5.012814999999989},{"latitude":43.590692,"longitude":5.012783000000013},{"latitude":43.590686,"longitude":5.012063000000012},{"latitude":43.590736,"longitude":5.011963000000009},{"latitude":43.590703,"longitude":5.011309000000011},{"latitude":43.590474,"longitude":5.010787999999991},{"latitude":43.590417,"longitude":5.010583999999994},{"latitude":43.590362,"longitude":5.010483999999991},{"latitude":43.59028,"longitude":5.0104709999999955},{"latitude":43.590162,"longitude":5.01059699999999},{"latitude":43.590123,"longitude":5.010829999999999},{"latitude":43.590134,"longitude":5.011072000000013},{"latitude":43.590067,"longitude":5.011323000000004},{"latitude":43.588908,"longitude":5.010250000000013}],"pois":[],"ascent":6,"length":1038,"status":4,"imageURL":"https://firebasestorage.googleapis.com/v0/b/miramas-498e5.appspot.com/o/ImageRoute%2Fle-defi-de-saint-suspi.jpg?alt=media&token=a74fb348-6b4e-469b-8a5f-6b7f819f0224","methodLocomotion":1,"globalAQI":0.0,"allergensAverage":0.0,"allergensInRoute":{},"arrayShareURL":{},"isNavigationActivated":true,"areSmartFactsEnabled":false,"isStartingPointStatic":true,"isSynthActivated":false,"isLoop":true,"arrayPOI":[],"arraySportsSession":[{"Status":4,"Description":{"EN":" ","FR":" "},"CheckedFR":true,"City":{"V0":true},"GPS":[{"Latitude":43.588825,"Longitude":5.01349}],"Range":20,"timeStamping":1593610607220,"IdType":"Non défini","Name":{"EN":"Cardio – Low impact","FR":"Cardio – Low impact"},"Checked":{"EN":false,"FR":true},"hasGPX":false,"IdCity":"V0","Sponsored":false,"EXO":{"EXO27":true,"EXO2":true,"EXO5":true,"EXO6":true},"id":"SS1"},{"Checked":{"EN":false,"FR":false},"Status":4,"Description":{"EN":" ","FR":" "},"IdCity":"V0","mainCoordinates":[0],"GPS":[{"Latitude":43.589677,"Longitude":5.013513}],"Range":20,"Sponsored":false,"timeStamping":1594385333796,"EXO":{"EXO28":true,"EXO7":true,"EXO8":true,"EXO9":true,"EXO10":true},"IdType":"Non défini","Name":{"EN":" ","FR":"Musculation membres supérieurs"},"id":"SS2"},{"Checked":{"EN":false,"FR":false},"Status":4,"Description":{"EN":" ","FR":" "},"IdCity":"V0","GPS":[{"Latitude":43.590607,"Longitude":5.013241}],"Range":20,"Sponsored":false,"timeStamping":1594385468438,"EXO":{"EXO12":true,"EXO11":true,"EXO14":true,"EXO13":true},"IdType":"Non défini","Name":{"EN":" ","FR":"Muscu inférieurs et équilibre"},"id":"SS3"},{"Checked":{"EN":false,"FR":false},"Status":4,"Description":{"EN":" ","FR":"Renforcement musculaire des membres supérieurs avec utilisation du poids du corps"},"IdCity":"V0","GPS":[{"Latitude":43.590769,"Longitude":5.011306}],"Range":20,"Sponsored":false,"timeStamping":1594385525325,"EXO":{"EXO16":true,"EXO15":true,"EXO18":true,"EXO17":true},"IdType":"Non défini","Name":{"EN":" ","FR":"Renforcement musculaire"},"id":"SS4"},{"Checked":{"EN":false,"FR":false},"Status":4,"Description":{"EN":" ","FR":" "},"IdCity":"V0","GPS":[{"Latitude":43.59002,"Longitude":5.011411}],"Range":40,"Sponsored":false,"timeStamping":1594385595164,"EXO":{"EXO26":true,"EXO23":true,"EXO25":true,"EXO24":true},"IdType":"Étirement","Name":{"EN":" ","FR":"Étirements"},"id":"SS5"},{"Checked":{"FR":true},"Status":4,"Description":{"EN":" ","FR":" "},"IdCity":"V0","CheckedFR":true,"GPS":[{"Latitude":43.590352,"Longitude":5.010531}],"Range":20,"Sponsored":false,"timeStamping":1595236262614,"EXO":{"EXO19":true,"EXO22":true,"EXO21":true,"EXO20":true},"IdType":"Non défini","Name":{"EN":" ","FR":"Renforcement cuisses abdos"},"id":"SS6"}]}',
                accessToken: "pk.eyJ1IjoibWlsZS1kZXYiLCJhIjoiY2s0OGJkNWEyMDB5ZTNna2Z5b2c2YTF3MCJ9.D5Ebdy0_ADSTQPTH4GCc9w",
                mode: widget.mode,
                whiteLabel: WhiteLabel(isWhiteLabel: true, beginInstruction: "Je démarre la navigation avec un texte custom.", endInstruction: "Le parcours est fini avec un texte custom."),
                languages: ["FR"],
                sponsor: "",
                gpsColor: "#AA87FF",
                distanceUnit: "metric",
                speedUnit: "kmh",
                locomotion: "walking",
                onMapCreated: (controller) {
                  print("onMapCreated");
                  this.navigationController = controller;
                },
                onNavigationStarted: (isStarted) {
                  setState(() {
                    navigationStarted = isStarted;
                  });
                },
                onActivePOI: (activePOI) {
                  print("onActivePOI");
                  if(activePOI.play) {
                    navigationController.playTTS("Description du POI en cours...");
                  }
                },
                onNavigationFinished: (routeFinished) {
                  print("onNavigationFinished");
                  Navigator.of(context).pop(); //Close this view
                },
                onEmergencySmsClick: () {
                  print("onEmergencySmsClick");
                },
                onReportClick: () {
                  print("onReportClick");
                },
                onMusicClick: () {
                  print("onMusicClick");
                },
                onSponsorClick: (sponsorId) {
                  print("onSponsorClick");
                },
                onActiveSportSession: (ssId) {
                  print("onActiveSportSession : " + ssId);
                },
              ),
            ),
            !navigationStarted ?
              InkWell(
                onTap: () {
                  Navigator.of(context).pop();
                },
                child: Container(
                  width: 30,
                  height: 30,
                  margin: EdgeInsets.only(top: 15, left: 15),
                  child: Icon(Platform.isIOS ? Icons.arrow_back_ios : Icons.arrow_back, color: Colors.white),
                ),
              )
            :
              Container(),
          ],
        ),
      ),
    );
  }
}
