//
//  LocationService.swift
//  NavigationUI
//
//  Created by Hassine on 17/06/2020.
//  Copyright © 2020 com.mile. All rights reserved.
//

import Foundation
import CoreLocation
import UIKit

public class LocationService: NSObject {
    
    
    public static let shared = LocationService.init()
    
    public let locationManager: CLLocationManager
    
    
    
    public override init() {
        self.locationManager = CLLocationManager()
        super.init()
        self.locationManager.desiredAccuracy = kCLLocationAccuracyHundredMeters
        self.locationManager.delegate = self
    }
    
    public func requestLocation() -> Void {
        self.locationManager.requestAlwaysAuthorization()
        self.locationManager.requestLocation()
    }
    
    public func getCurrentLocation() -> CLLocation? {
        return self.locationManager.location
    }
    
    public func startUpdatelocation() -> Void {
        print("The updating location is started")
        self.locationManager.startUpdatingLocation()
    }
    
    public func stopUpdatingLocation() -> Void {
        print("The updating location is stopped")
        self.locationManager.stopUpdatingLocation()
    }
    
    public func getStateLocation() -> CLAuthorizationStatus {
       return CLLocationManager.authorizationStatus()
    }

    public func getStateLocation(_ callBack:@escaping (CLAuthorizationStatus) -> Void)
    {
        callBack(CLLocationManager.authorizationStatus())
    }
    
}

extension LocationService: CLLocationManagerDelegate {
    
    public func locationManager(_ manager: CLLocationManager, didUpdateLocations locations:[CLLocation]) {
        guard let location = locations.first else { return }
        print("The location is: \(location)")
    }
    
    public func locationManager(_ manager: CLLocationManager, didFailWithError error: Error) {
        print("Error: \(error)")
    }
    
    public func locationManager(_ manager: CLLocationManager, didChangeAuthorization status: CLAuthorizationStatus) {
        print("status  \(status)")
        //  UIApplication.shared.open(URL(string:"App-Prefs:root=LOCATION_SERVICES")!, options: [:], completionHandler: nil)
        switch status {
        case .denied:
      break
            
            
        default:
            print("error")
        }
    }
}

