//
//  OfflineDatas.swift
//  v4_navigation_engine
//
//  Created by Lionel Malloggi on 22/06/2020.
//

import Foundation
import CoreLocation

public struct SportSession {

    static var ID_FIELD = "id";
    static var COORDINATE_FIELD = "GPS";
    static var RANGE_FIELD = "Range";

    public var key : String?
    public var gps: [CLLocationCoordinate2D] = []
    public var radius: Int?
    public var status: PoiStatuts = .notPlayed

    init(dict: [String: Any]) {
        self.key = dict[SportSession.ID_FIELD] as? String
        self.radius = dict[SportSession.RANGE_FIELD] as? Int

        if let coordinates = dict[SportSession.COORDINATE_FIELD] as? [[String: Double]] {
            for coordinate in coordinates{
                let latitude = coordinate["Latitude"] ?? 0
                let longitude = coordinate["Longitude"] ?? 0
                let gpx = CLLocationCoordinate2D.init(latitude: latitude, longitude: longitude)
                self.gps.append(gpx)
            }
        }
    }
}
