//
//  CustomCell.swift
//  NavigationUI
//
//  Created by Hassine on 20/08/2020.
//  Copyright © 2020 com.mile. All rights reserved.
//

import UIKit
import LiquidFloatingActionButton

public class CustomCell : LiquidFloatingCell {
    var name: String = "sample"
    let label = UILabel()
    
    init(icon: UIImage, name: String) {
        self.name = name
        super.init(icon: icon)
    }

    required public init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

    public override func setupView(_ view: UIView) {
        super.setupView(view)
        
        label.text = name
        label.textAlignment = .right
        label.textColor = Style.shared.primaryColor
        label.font = UIFont(name: "GothamRounded-Medium", size: 13)
        addSubview(label)
        label.snp.makeConstraints { make in
            make.left.equalTo(self).offset(-250)
            make.width.equalTo(240)
            make.top.height.equalTo(self)
        }
    }
}
