//
//  MyNavigationViewUI.swift
//  NavigationUI
//
//  Created Hassine on 10/03/2020.
//  Copyright © 2020 com.mile. All rights reserved.
//

import UIKit

// MARK: MyNavigationViewUI Delegate -
/// MyNavigationViewUI Delegate
protocol MyNavigationViewUIDelegate {
    // Send Events to Module View, that will send events to the Presenter; which will send events to the Receiver e.g. Protocol OR Component.
}

// MARK: MyNavigationViewUI Data Source -
/// MyNavigationViewUI Data Source
protocol MyNavigationViewUIDataSource {
    // This will be implemented in the Module View.
    /// Set Object for the UI Component
    func objectFor(ui: MyNavigationViewUI) -> MyNavigationEntity
}

class MyNavigationViewUI: UIView {
    
    var delegate: MyNavigationViewUIDelegate?
    var dataSource: MyNavigationViewUIDataSource?
    
    var object : MyNavigationEntity?
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupUIElements()
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
    }
    
    override func didMoveToWindow() {
        super.didMoveToWindow()
        setupConstraints()
    }
    
    fileprivate func setupUIElements() {
        // arrange subviews
    }
    
    fileprivate func setupConstraints() {
        // add constraints to subviews
    }
    
    /// Reloading the data and update the ui according to the new data
    func reloadData() {
        self.object = dataSource?.objectFor(ui: self)
        // Should update UI
    }
}
