
//
//  MYSlidingButton.swift
//  NavigationUI
//
//  Created by hassine othmane on 3/20/20.
//  Copyright © 2020 com.mile. All rights reserved.
//

import UIKit



@IBDesignable class MySlidingButton: UIView{



    var layoutSet            = false
    var unlocked             = false
   


    @IBInspectable var dragPointWidth: CGFloat = 80 {
        didSet{
            //setStyle()
        }
    }

    @IBInspectable var dragPointColor: UIColor = UIColor.darkGray {
        didSet{
            //setStyle()
        }
    }


    override init (frame : CGRect) {
           super.init(frame : frame)
       }

       required init(coder aDecoder: NSCoder) {
           super.init(coder: aDecoder)!

       }

    var dragPoint            = UIView()
    var buttons            = UIView()

       override func layoutSubviews() {
           if !layoutSet{
               self.setUpButton()
               self.layoutSet = true
           }
       }


    func setUpButton(){

        //self.backgroundColor              = self.buttonColor

        self.dragPoint                    = UIView(frame: CGRect(x:  0, y: 0, width: dragPointWidth, height: dragPointWidth))
        self.buttons                      = UIView(frame: CGRect(x:  dragPointWidth-self.frame.size.width, y: 0, width: self.frame.width, height: dragPointWidth))

        self.dragPoint.backgroundColor    = dragPointColor
        self.buttons.backgroundColor    = dragPointColor

        self.dragPoint.layer.cornerRadius = dragPointWidth/2
        self.dragPoint.layer.borderWidth = 15
        self.dragPoint.layer.borderColor = UIColor(red:0.71, green:0.73, blue:0.76, alpha:1.00).cgColor

        self.addSubview(self.buttons)
        self.addSubview(self.dragPoint)


        // start detecting pan gesture
               let panGestureRecognizer                    = UIPanGestureRecognizer(target: self, action: #selector(self.panDetected(sender:)))
               panGestureRecognizer.minimumNumberOfTouches = 1

         self.dragPoint.addGestureRecognizer(panGestureRecognizer)
        //self.buttons.addGestureRecognizer(panGestureRecognizer)

//        if !self.buttonText.isEmpty{
//
//            self.buttonLabel               = UILabel(frame: CGRect(x: 0, y: 0, width: self.frame.size.width, height: self.frame.size.height))
//            self.buttonLabel.textAlignment = .center
//            self.buttonLabel.text          = buttonText
//            self.buttonLabel.textColor     = UIColor.white
//            self.buttonLabel.font          = self.buttonFont
//            self.buttonLabel.textColor     = self.buttonTextColor
//            self.addSubview(self.buttonLabel)
//
//            self.dragPointButtonLabel               = UILabel(frame: CGRect(x: 0, y: 0, width: self.frame.size.width, height: self.frame.size.height))
//            self.dragPointButtonLabel.textAlignment = .center
//            self.dragPointButtonLabel.text          = buttonText
//            self.dragPointButtonLabel.textColor     = UIColor.white
//            self.dragPointButtonLabel.font          = self.buttonFont
//            self.dragPointButtonLabel.textColor     = self.dragPointTextColor
//            self.dragPoint.addSubview(self.dragPointButtonLabel)
//        }
//        self.bringSubviewToFront(self.dragPoint)
//
//        if self.imageName != UIImage(){
//            self.imageView = UIImageView(frame: CGRect(x: self.frame.size.width - dragPointWidth, y: 0, width: self.dragPointWidth, height: self.frame.size.height))
//            self.imageView.contentMode = .center
//            self.imageView.image = self.imageName
//            self.dragPoint.addSubview(self.imageView)
//        }

//        self.layer.masksToBounds = true
//
//        // start detecting pan gesture
//        let panGestureRecognizer                    = UIPanGestureRecognizer(target: self, action: #selector(self.panDetected(sender:)))
//        panGestureRecognizer.minimumNumberOfTouches = 1
//        self.dragPoint.addGestureRecognizer(panGestureRecognizer)
    }

    @objc func panDetected(sender: UIPanGestureRecognizer){
        var translatedPoint = sender.translation(in: self)
        translatedPoint     = CGPoint(x: translatedPoint.x, y: self.frame.size.height / 2)
        sender.view?.frame.origin.x = (0) + translatedPoint.x
        buttons.frame.origin.x = (0) + translatedPoint.x - buttons.frame.width + 20
        if sender.state == .ended{

            let velocityX = sender.velocity(in: self).x * 0.2
            var finalX    = translatedPoint.x + velocityX
            if finalX < 0{
                finalX = 0
            }else if finalX + self.dragPointWidth  >  (self.frame.size.width - 60){
                unlocked = true
                self.unlock()
            }

            let animationDuration:Double = abs(Double(velocityX) * 0.0002) + 0.2
            UIView.transition(with: self, duration: animationDuration, options: UIView.AnimationOptions.curveEaseOut, animations: {
                }, completion: { (Status) in
                    if Status{
                        self.animationFinished()
                    }
            })
        }
    }

    func animationFinished(){
       
           if !unlocked{
               self.reset()
           }
       }

       //lock button animation (SUCCESS)
       func unlock(){
        UIView.animate(withDuration: 0.6) {
            self.dragPoint.isHidden = true
        }
           UIView.transition(with: self, duration: 0.2, options: .curveEaseOut, animations: {
              // self.dragPoint.frame = CGRect(x: 0, y: 0, width: self.dragPoint.frame.size.width, height: self.dragPoint.frame.size.height)
           }) { (Status) in
               if Status{
                //   self.dragPointButtonLabel.text      = self.buttonUnlockedText
                 //  self.imageView.isHidden               = true
                   self.dragPoint.backgroundColor      = self.dragPointColor
              //     self.dragPointButtonLabel.textColor = self.buttonUnlockedTextColor
              //     self.delegate?.buttonStatus(status: "Unlocked", sender: self)
               }
           }
       }

    //reset button animation (RESET)
    func reset(){
        UIView.transition(with: self, duration: 0.2, options: .curveEaseOut, animations: {
            self.dragPoint.frame = CGRect(x: 0, y: 0, width: self.dragPoint.frame.size.width, height: self.dragPoint.frame.size.height)
        }) { (Status) in
            if Status{
              //  self.dragPointButtonLabel.text      = self.buttonText
              //  self.imageView.isHidden               = false
                self.dragPoint.backgroundColor      = self.dragPointColor
              //  self.dragPointButtonLabel.textColor = self.dragPointTextColor
                self.unlocked                       = false
                //self.delegate?.buttonStatus("Locked")
            }
        }
    }



}
