//
//  AudioService.swift
//  NavigationUI
//
//  Created by hassine othmane on 5/28/20.
//  Copyright © 2020 com.mile. All rights reserved.
//

/*import Foundation
import AVFoundation
import AudioToolbox

import AVFoundation


protocol AudioServiceDelegate {
    func launchSmartRun()
    func endSmartRunNavigation(routeCompleted : Bool)
}


extension AVSpeechSynthesisVoice {

    enum Language: String {
        case English = "en-US" //by default, we use US region
        case French = "fr-FR" //by default, we use France region
        case Dutch = "nl-NL"
        case Spanish = "es-ES"
        case Italian = "it-IT"
        case German = "de-DE"
    }

    enum Genre {
        case    Male
        case    Female
    }
    class func selectVoice(forLanguage: Language, preferredGenre: Genre) -> AVSpeechSynthesisVoice {

        //Used to select the right Siri Bundle identifier in language. If the Siri identifier not exists, we switch to the default language Voice.
        var identifier: String?
        //Look for the user current language code/
        //  let currentlocal = Locale.current
        // let localeIdentifier = currentlocal.languageCode! + "-" + currentlocal.regionCode! //example : English language with regionCode US will return en-US
        switch forLanguage {
        case Language.English:
            let languageVoices = AVSpeechSynthesisVoice.speechVoices().filter({$0.language == Language.English.rawValue}) //We filter array voices with content language
            let enhancedVoices = languageVoices.filter({$0.quality == AVSpeechSynthesisVoiceQuality.enhanced}) //We filter language voice array with quality
            let compactVoices = languageVoices.filter({$0.quality == AVSpeechSynthesisVoiceQuality.default})

            switch preferredGenre {
            case Genre.Male:
                let maleVoicesName = ["siri_male","Tom","Alex"]
                for voice in enhancedVoices {
                    for maleName in maleVoicesName {
                        if voice.identifier.contains(maleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                for voice in compactVoices {
                    for maleName in maleVoicesName {
                        if voice.identifier.contains(maleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                //Default voice if no identifier has been found
                return AVSpeechSynthesisVoice.init(language: Language.English.rawValue)!

            case Genre.Female:

                let femaleVoicesName = ["siri_female","Ava","Allison"]
                for voice in enhancedVoices {
                    for maleName in femaleVoicesName {
                        if voice.identifier.contains(maleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                for voice in compactVoices {
                    for maleName in femaleVoicesName {
                        if voice.identifier.contains(maleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }


                //Default voice if no identifier has been found
               return AVSpeechSynthesisVoice.init(language: Language.English.rawValue)!

            }
        case Language.French:

            let languageVoices = AVSpeechSynthesisVoice.speechVoices().filter({$0.language == Language.French.rawValue}) //We filter array voices with content language
            let enhancedVoices = languageVoices.filter({$0.quality == AVSpeechSynthesisVoiceQuality.enhanced}) //We filter language voice array with quality
            let compactVoices = languageVoices.filter({$0.quality == AVSpeechSynthesisVoiceQuality.default})


            switch preferredGenre {
            case Genre.Male:
                let maleVoicesName = ["siri_male","Thomas"]

                //Priority to enhanced voices
                for voice in enhancedVoices {
                    for maleName in maleVoicesName {
                        if voice.identifier.contains(maleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                //else fall back with compacts voices
                for voice in compactVoices {
                    for maleName in maleVoicesName {
                        if voice.identifier.contains(maleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                //Default voice if no identifier has been found
                return AVSpeechSynthesisVoice.init(language: Language.French.rawValue)!

            case Genre.Female:
                let femaleVoicesName = ["siri_female","Audrey","Aurelie"]
                for voice in enhancedVoices {
                    for femaleName in femaleVoicesName {
                        if voice.identifier.contains(femaleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                for voice in compactVoices {
                    for femaleName in femaleVoicesName {
                        if voice.identifier.contains(femaleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }


                //Default voice if no identifier has been found
                return AVSpeechSynthesisVoice.init(language: Language.French.rawValue)!
            }
        case Language.Dutch:
            switch preferredGenre {
            case Genre.Male:
                identifier =  "com.apple.ttsbundle.Xander-compact" //Xander has a Netherland accent.
                return AVSpeechSynthesisVoice.init(identifier: identifier!)!

            case Genre.Female:
                identifier =  "com.apple.ttsbundle.Ellen-compact" //Ellen has a Belgium accent.
                return AVSpeechSynthesisVoice.init(identifier: identifier!)!
            }
        case .Spanish:
            let languageVoices = AVSpeechSynthesisVoice.speechVoices().filter({$0.language == Language.Spanish.rawValue}) //We filter array voices with content language
            let enhancedVoices = languageVoices.filter({$0.quality == AVSpeechSynthesisVoiceQuality.enhanced}) //We filter language voice array with quality
            let compactVoices = languageVoices.filter({$0.quality == AVSpeechSynthesisVoiceQuality.default})

            switch preferredGenre {
            case Genre.Male:

                let maleVoicesName = ["siri_male","Jorge","Juan"]

                for voice in enhancedVoices {
                    for maleName in maleVoicesName {
                        if voice.identifier.contains(maleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                for voice in compactVoices {
                    for maleName in maleVoicesName {
                        if voice.identifier.contains(maleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                //Default voice if no identifier has been found
                return AVSpeechSynthesisVoice.init(language: Language.Spanish.rawValue)!


            case Genre.Female:
                let femaileVoicesName = ["siri_female","Monica","Marisol","Paulina","Angelica"]
                for voice in enhancedVoices {
                    for femaleName in femaileVoicesName {
                        if voice.identifier.contains(femaleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                for voice in compactVoices {
                    for femaleName in femaileVoicesName {
                        if voice.identifier.contains(femaleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                //Default voice if no identifier has been found
                return AVSpeechSynthesisVoice.init(language: Language.Spanish.rawValue)!

            }
        case .Italian:
            let languageVoices = AVSpeechSynthesisVoice.speechVoices().filter({$0.language == Language.Italian.rawValue}) //We filter array voices with content language
            let enhancedVoices = languageVoices.filter({$0.quality == AVSpeechSynthesisVoiceQuality.enhanced}) //We filter language voice array with quality
            let compactVoices = languageVoices.filter({$0.quality == AVSpeechSynthesisVoiceQuality.default})

            switch preferredGenre {
            case Genre.Male:

                let maleVoicesName = ["siri_male","Luca"]
                for voice in enhancedVoices {
                    for maleName in maleVoicesName {
                        if voice.identifier.contains(maleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                for voice in compactVoices {
                    for maleName in maleVoicesName {
                        if voice.identifier.contains(maleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                //Default voice if no identifier has been found
                identifier = "com.apple.ttsbundle.Alice-compact"
                return AVSpeechSynthesisVoice.init(identifier: identifier!)!


            case Genre.Female:
                let femaileVoicesName = ["siri_female","Alice","Federica"]
                for voice in enhancedVoices {
                    for femaleName in femaileVoicesName {
                        if voice.identifier.contains(femaleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                for voice in compactVoices {
                    for femaleName in femaileVoicesName {
                        if voice.identifier.contains(femaleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }


                //Default voice if no identifier has been found
                identifier = "com.apple.ttsbundle.Alice-compact"
                return AVSpeechSynthesisVoice.init(identifier: identifier!)!
            }
        case .German:
            let languageVoices = AVSpeechSynthesisVoice.speechVoices().filter({$0.language == Language.German.rawValue}) //We filter array voices with content language
            let enhancedVoices = languageVoices.filter({$0.quality == AVSpeechSynthesisVoiceQuality.enhanced}) //We filter language voice array with quality
            let compactVoices = languageVoices.filter({$0.quality == AVSpeechSynthesisVoiceQuality.default})

            switch preferredGenre {
            case Genre.Male:

                let maleVoicesName = ["siri_male","Yannick","Markus"]
                for voice in enhancedVoices {
                    for maleName in maleVoicesName {
                        if voice.identifier.contains(maleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                for voice in compactVoices {
                    for maleName in maleVoicesName {
                        if voice.identifier.contains(maleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                //Default voice if no identifier has been found
                identifier = "com.apple.ttsbundle.Anna-compact"
                return AVSpeechSynthesisVoice.init(identifier: identifier!)!

            case Genre.Female:
                let femaileVoicesName = ["siri_female","Anna"]
                for voice in enhancedVoices {
                    for femaleName in femaileVoicesName {
                        if voice.identifier.contains(femaleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                for voice in compactVoices {
                    for femaleName in femaileVoicesName {
                        if voice.identifier.contains(femaleName) {
                            identifier = voice.identifier
                            return AVSpeechSynthesisVoice.init(identifier: identifier!)!
                        }
                    }
                }

                //Default voice if no identifier has been found
                identifier = "com.apple.ttsbundle.Anna-compact"
                return AVSpeechSynthesisVoice.init(identifier: identifier!)!
            }
        }
    }
}

class AudioService: NSObject, AVAudioPlayerDelegate, AVSpeechSynthesizerDelegate {


    // Bool variables
    static let sharedInstance = AudioService()
    var isWaitingForSpeak = false
    var isSpeaking = false // AVSpeechSynthesizer isSpeaking always return true even if it is not speaking. So we use our own bool
    // Int variables
    var wordCounter:Int = 0
    var timerCounter: Float = 0
    var resourceForTTS: LanguageRessource!
    var delayBeforeSessionDeactivate: Double = 0 //used to changed delay before deactivating session

    // Timers
    var timerUterrance = Timer()
  //  var skttsLanguage = SKAdvisorLanguage.EN_US
    var arrayStringPOIQueue:        Array<String> = [] //Used to keep a reference of ongoing poi utterance.

    //Parcours des Informations Touristiques
    var onGoingUtterance            = AVSpeechUtterance()
    var theSession                  = AVAudioSession()
    var currentSynth                = AVSpeechSynthesizer()
    var delegate:                   AudioServiceDelegate!
    var player :                    AVAudioPlayer!
    var askToDeactivateSession = false
    enum AudioContent {
        case start_navigation
        case start_navigation_static_firstpoint
        case resume_navigation
        case pause_navigation
        case routeReached
        case orientationChanged
    }

    //MARK: Lifecycle
    fileprivate override init() {
        super.init()
        currentSynth = AVSpeechSynthesizer()
    }

    deinit {
        currentSynth = AVSpeechSynthesizer()
    }


    /********************************/
    /***** Audio configuration ******/
    /********************************/

    var voiceFemale: AVSpeechSynthesisVoice! //Configured with available language.
    var voiceMale : AVSpeechSynthesisVoice! //Configured with app localization.

    func configure(language: String){
        refreshInstance()
        resourceForTTS = LanguageRessource(languageSelected: language)
        configureAudioPlayerTTS(languageSelected:language)
    }

    private func configureAudioPlayerTTS(languageSelected: String) {
        //print("voices TTS available : " + AVSpeechSynthesisVoice.speechVoices().description)

        theSession = AVAudioSession.sharedInstance()
        NotificationCenter.default.addObserver(self, selector: #selector(AudioService.playInterrupt), name: AVAudioSession.interruptionNotification, object: theSession)
       // let advisorSettings = SKAdvisorSettings()


        //We know the POIs content language. So we use the right TTS
        switch languageSelected {
        case "French" :
          //  skttsLanguage = SKAdvisorLanguage.FR
           // advisorSettings.advisorVoice = "fr"
            voiceFemale = AVSpeechSynthesisVoice.selectVoice(forLanguage: AVSpeechSynthesisVoice.Language.French, preferredGenre: AVSpeechSynthesisVoice.Genre.Female)
            voiceMale = AVSpeechSynthesisVoice.selectVoice(forLanguage: AVSpeechSynthesisVoice.Language.French, preferredGenre: AVSpeechSynthesisVoice.Genre.Male)
        case ".english":
           // skttsLanguage = SKAdvisorLanguage.EN_US
          //  advisorSettings.advisorVoice = "en_us"
            voiceFemale = AVSpeechSynthesisVoice.selectVoice(forLanguage: AVSpeechSynthesisVoice.Language.English, preferredGenre: AVSpeechSynthesisVoice.Genre.Female)
            voiceMale = AVSpeechSynthesisVoice.selectVoice(forLanguage: AVSpeechSynthesisVoice.Language.English, preferredGenre: AVSpeechSynthesisVoice.Genre.Male)
        case ".dutch":
           // skttsLanguage = SKAdvisorLanguage.NL
         //   advisorSettings.advisorVoice = "nl
            voiceFemale = AVSpeechSynthesisVoice.selectVoice(forLanguage: AVSpeechSynthesisVoice.Language.Dutch, preferredGenre: AVSpeechSynthesisVoice.Genre.Female)
            voiceMale = AVSpeechSynthesisVoice.selectVoice(forLanguage: AVSpeechSynthesisVoice.Language.Dutch, preferredGenre: AVSpeechSynthesisVoice.Genre.Male)
        case ".spanish":
         //   skttsLanguage = SKAdvisorLanguage.ES
         //   advisorSettings.advisorVoice = "es"
            voiceFemale = AVSpeechSynthesisVoice.selectVoice(forLanguage: AVSpeechSynthesisVoice.Language.Spanish, preferredGenre: AVSpeechSynthesisVoice.Genre.Female)
            voiceMale = AVSpeechSynthesisVoice.selectVoice(forLanguage: AVSpeechSynthesisVoice.Language.Spanish, preferredGenre: AVSpeechSynthesisVoice.Genre.Male)
        case ".italian":
           // skttsLanguage = SKAdvisorLanguage.IT
          //  advisorSettings.advisorVoice = "it"
            voiceFemale = AVSpeechSynthesisVoice.selectVoice(forLanguage: AVSpeechSynthesisVoice.Language.Italian, preferredGenre: AVSpeechSynthesisVoice.Genre.Female)
            voiceMale = AVSpeechSynthesisVoice.selectVoice(forLanguage: AVSpeechSynthesisVoice.Language.Italian, preferredGenre: AVSpeechSynthesisVoice.Genre.Male)
        case ".german":
         //   skttsLanguage = SKAdvisorLanguage.DE
          //  advisorSettings.advisorVoice = "de"
            voiceFemale = AVSpeechSynthesisVoice.selectVoice(forLanguage: AVSpeechSynthesisVoice.Language.German, preferredGenre: AVSpeechSynthesisVoice.Genre.Female)
            voiceMale = AVSpeechSynthesisVoice.selectVoice(forLanguage: AVSpeechSynthesisVoice.Language.German, preferredGenre: AVSpeechSynthesisVoice.Genre.Male)
        default:
            break
        }

        let newSynthesizer = AVSpeechSynthesizer()
        newSynthesizer.delegate = self
        currentSynth = newSynthesizer
       // advisorSettings.language = skttsLanguage
      //  advisorSettings.advisorType = SKAdvisorType.textToSpeech
    //    SKRoutingService.sharedInstance().advisorConfigurationSettings = advisorSettings
    }

    func initializeSynthesizer() {
        let newSynthesizer = AVSpeechSynthesizer()
        newSynthesizer.delegate = self
        currentSynth = newSynthesizer
    }


    /********************************/
    /******* Custom function ********/
    /********************************/

    func playTTSFromAnnotation(stringToPlay: String){
        arrayStringPOIQueue.removeAll()
        playTTS(stringToPlay: stringToPlay, priority: false)
    }

    func playTTS(stringToPlay: String, priority: Bool){
        //WARNING : this function must not be modified without a carefull test session. Audio Session activation / deactivation can produce a major audio crash -> no crash report but all app audio would stop and the user could not understand why.
        //This case happens when the audiosession is being cancelled when the TTS is about to speak.

        ///replayStoppedUtterance : used to define if the new prio utterance should, when ended, replay previously stopped POI.

        guard voiceFemale != nil && voiceMale != nil else {
            return
        }

        NSLog("speak string " + stringToPlay)
        if stringToPlay != "" {
            if priority == true {
                // The Utterance has the priority
                //We check if the queue of POI is empty
                if arrayStringPOIQueue.isEmpty {
                    //the queue of POI is empty
                    //We can play the new utterance

                    let delay = DispatchTime.now() + delayBeforeSessionDeactivate //deactivationSessionTimer can be 0, depending on audiosession being activate/deactivate
                    //The better is to put a delay before speak, but we can't write a Timer with block in iOS<10.0
                    DispatchQueue.main.asyncAfter(deadline: delay) {
                        self.launchSpeak(stringToSpeak: stringToPlay, withVoice: self.voiceMale)
                    }

                    print("A")

                } else {
                    //The queue of POI is not empty
                    //We need to add our utterance in priority to the queue of POIs

                    //We check if an utterance has started to play
                    if isSpeaking {
                        //An utterance is playing and not finished
                        //We check if the utterance playing before this interruption was a POI or a DIR
                        if arrayStringPOIQueue.contains(onGoingUtterance.speechString) == true {
                            print("B")

                            currentSynth.stopSpeaking(at: .word)
                            interruptionNeedToStop()
                            //We play our utterance that has the priority
                            launchSpeak(stringToSpeak: stringToPlay, withVoice: voiceMale)


                            //Utterance playing is a POI, so we stop it and create a new POI string to end the description after this prio utterance
                            let lastPOIUtterance = onGoingUtterance.speechString
                            var newString = ""
                            //We stop the reading because stringToPlay has priority
                            //We clean the queue of TTS

                            //We look for the string of the POis that has been stopped and recreate the string from the interruption word point.
                            if arrayStringPOIQueue.firstIndex(of: lastPOIUtterance) != nil {
                                //We are sure that it was a POIs
                                //We are going to create the new String that will be read
                                let words = lastPOIUtterance.components(separatedBy: " ")

                                if wordCounter > words.count {
                                    //This condition is due to a one time error during debug : wordCounter was one word more than words.count. This cause Range Fatal error upperBound < lowerBound
                                    wordCounter = words.count
                                }
                                for i in wordCounter  ..< words.count {
                                    //we create a new string with the part of the utterance that has NOT been spoken.
                                    newString =  newString + " " + words[i]
                                }
                                wordCounter = 0
                                arrayStringPOIQueue[arrayStringPOIQueue.firstIndex(of: lastPOIUtterance)!] = newString
                            }

                            //And finally, we add all POI left
                            for i in 0 ..< arrayStringPOIQueue.count {
                                //used to read each utterance that has not been spoken and that are still in the queue
                                launchSpeak(stringToSpeak: arrayStringPOIQueue[i], withVoice: voiceFemale)
                            }


                        }else{
                            //A POI was playing, we stop it to speak the priority utterance
                            print("C")
                            print("speaking utterance : " + onGoingUtterance.speechString)
                            currentSynth.stopSpeaking(at: .word)
                            interruptionNeedToStop()
                            self.launchSpeak(stringToSpeak: stringToPlay, withVoice: voiceMale)

                            for i in 0 ..< arrayStringPOIQueue.count {
                                //used to read each utterance that has not been spoken and that are still in the queue
                                launchSpeak(stringToSpeak: arrayStringPOIQueue[i], withVoice: voiceFemale)
                            }


                        }
                    }else{
                        print("D")

                        //The POI did not start yet, but we have to stopSpeaking to clear the queue.
                        //Then we read the current DIR even if a POI is speaking
                        currentSynth.stopSpeaking(at: .word)
                        interruptionNeedToStop()
                        self.launchSpeak(stringToSpeak: stringToPlay, withVoice: voiceMale)

                        //And finally, we add all POI left
                        for i in 0 ..< arrayStringPOIQueue.count {
                            //used to read each utterance that has not been spoken and that are still in the queue
                            launchSpeak(stringToSpeak: arrayStringPOIQueue[i], withVoice: voiceFemale)
                        }


                        print("will speak a direction and adding POI queue")

                    }
                }

            }else{
                print("E")
                //We can just play our POIs
                let delay = DispatchTime.now() + delayBeforeSessionDeactivate //deactivationSessionTimer can be 0, depending on audiosession being activate/deactivate

                DispatchQueue.main.asyncAfter(deadline: delay) {
                    self.launchSpeak(stringToSpeak: stringToPlay, withVoice: self.voiceFemale)
                }

            }
        }
    }

    fileprivate func refreshInstance(){
        self.arrayStringPOIQueue.removeAll()
        isWaitingForSpeak = false
        isSpeaking = false // AVSpeechSynthesizer isSpeaking always return true even if it is not speaking. So we use our own bool
        wordCounter = 0
        timerCounter = 0

        // Timers
        timerUterrance = Timer()

        //Parcours des Informations Touristiques
        onGoingUtterance            = AVSpeechUtterance()
        theSession                  = AVAudioSession()
        currentSynth                = AVSpeechSynthesizer()

        askToDeactivateSession = false
    }

    func launchSpeak(stringToSpeak : String, withVoice: AVSpeechSynthesisVoice) {
        //We are going to speak, and we watch for a boolean value to know if the TTS has start speaking
        waitForSpeaking()

        //Description POI speak string
        let newUtterance = AVSpeechUtterance(string: stringToSpeak)
        newUtterance.preUtteranceDelay = 0.3
        newUtterance.postUtteranceDelay = 0.3
        if withVoice.name == "Audrey" {
            newUtterance.rate = 0.51
        }else{
            newUtterance.rate = 0.47
        }

        newUtterance.voice = withVoice
        currentSynth.speak(newUtterance)

    }

    /********************************/
    /********** TTS Delegate ********/
    /********************************/

    func audioPlayerDidFinishPlaying(_ player: AVAudioPlayer, successfully flag: Bool) {
        self.deactivateSession()
        sendNotification(isPlaying: false)
    }

    func speechSynthesizer(_ synthesizer: AVSpeechSynthesizer, didStart utterance: AVSpeechUtterance) {
        print("did start")
        sendNotification(isPlaying: true)


    }

    func speechSynthesizer(_ synthesizer: AVSpeechSynthesizer, didCancel utterance: AVSpeechUtterance) {
        NSLog("cancel tts")
        isSpeaking = false
        sendNotification(isPlaying: false)
    }



    func speechSynthesizer(_ synthesizer: AVSpeechSynthesizer, didFinish utterance: AVSpeechUtterance) {
        let finishedUtterance = AVSpeechUtterance(string: "")

        isSpeaking = false
        sendNotification(isPlaying: false)
        print("did finish")

        onGoingUtterance = finishedUtterance


        if arrayStringPOIQueue.firstIndex(of: utterance.speechString) != nil {
            //We suppress the utterance from the queue of POI
            print("POI in queue before removing : " + arrayStringPOIQueue.count.description)
            arrayStringPOIQueue.remove(at: arrayStringPOIQueue.firstIndex(of: utterance.speechString)!)
        }

        //We check if the queue is empty
        if  arrayStringPOIQueue.isEmpty {
            if utterance.speechString != "" {

                delayBeforeSessionDeactivate = 1.4 //we will wait at least 1.4 second before speaking the next String. It avoids problem of deactivation

                Timer.scheduledTimer(timeInterval: 0.4, target: self, selector: #selector(AudioService.deactivateSession), userInfo: nil, repeats: false)
                //After 1.4s, if no string is asked to play, we reinit deactivationSessionTimer to 0.
                Timer.scheduledTimer(timeInterval: 1.4, target: self, selector: #selector(AudioService.endDeactivation), userInfo: nil, repeats: false)
            }
        }

        if utterance.speechString == resourceForTTS.endRoute { //When the TTS finished annoucing the end of the Smart Run, we open the Evaluation
            delegate.endSmartRunNavigation(routeCompleted: true)
        }

        if utterance.speechString.contains(resourceForTTS.moreSponsorInformations) {
            delegate.launchSmartRun()
        }

        wordCounter = 0
        if askToDeactivateSession {
            NSLog("Utterence finish, we can deactivate sessions")
            deactivateSession()
        }
    }

    func speechSynthesizer(_ synthesizer: AVSpeechSynthesizer, willSpeakRangeOfSpeechString characterRange: NSRange, utterance: AVSpeechUtterance) {
        //This delegate is called everytime a word of an utterance is spoken
        isSpeaking = true
        onGoingUtterance = utterance
        // We keep the utterance that is currently spoken in case of a rerouting.
        wordCounter = wordCounter + 1
        //The synthesizer is speaking, no need to wait for utterance
        isWaitingForSpeak = false
    }

    /********************************/
    /********** Duck-Unduck *********/
    /********************************/

    @objc func endDeactivation() {
        delayBeforeSessionDeactivate = 0
    }


    func stopFromAnnotation(){
        arrayStringPOIQueue.removeAll()
        deactivateSession()
    }
    @objc func deactivateSession(){
        //This function is used to unduck the music (outside music, like Spotify ...) after we finished playing sound from our app
        stopSpeaking()
        let when = DispatchTime.now() + 0.2 // We wait a little after cancel TTS to deativate session (if TTS is still speaking, we must no deactivate session because this could lead to crash audio.)
        DispatchQueue.main.asyncAfter(deadline: when) {
            do {
                if !self.isSpeaking {
                    if self.player != nil {
                        guard !self.player.isPlaying else {
                            //AVAudioPlayer must not play audio
                            NSLog("Skip session deactivation because AVAudioPlayer is playing")
                            return
                        }
                    }
                    try self.theSession.setActive(false)
                    NSLog("Session deactivated")
                }else{
                    //Si le TTS parlait on a pas pu desactiver la session. On ajoute donc un bool pour le faire en fin de phrase
                    self.askToDeactivateSession = true
                    NSLog("Will deactivate session after speech")
                }
            } catch {
                NSLog("Problem with the deactivation of the session")
            }
        }
    }

    func activateSession(){
        //Only trigger once at beginning. Then duck will be done by deactivating theSession
        do {
            stopSpeaking()
            //     try theSession.setCategory([AVAudioSession.Category.playback], options: AVAudioSession.CategoryOptions.mixWithOthers, [AVAudioSession.CategoryOptions.duckOthers])
            try theSession.setCategory(AVAudioSession.Category.playback)
         //   try theSession.setCategory(AVAudioSessionCategoryPlayback, with:[ .mixWithOthers, .duckOthers])
            try theSession.setActive(true)
            NSLog("Session activated")
        } catch {
            NSLog("Session deactiva")
        }
    }

    /********************************/
    /********* Interruption *********/
    /********************************/

    func stopPOIplaying(){
        deactivateSession()
    }
    private func stopSpeaking(){
        if isSpeaking {
            currentSynth.stopSpeaking(at: .immediate)
        }
    }

    @objc func playInterrupt(notification: NSNotification) {
        if notification.name == AVAudioSession.interruptionNotification && notification.userInfo != nil {
            var info = notification.userInfo!
            var intValue: UInt = 0
            print(info)

            (info[AVAudioSessionInterruptionTypeKey] as! NSValue).getValue(&intValue)
            if let type = AVAudioSession.InterruptionType(rawValue: intValue)
            {
                switch type
                {
                case .began:
                    deactivateSession()
                case .ended: break
                    //Nothing to handle there.
                }
            }
        }
    }

    func interruptionNeedToStop() {
        //Before to play any sound, we have to initialize the synthesizer because the interruption hasn't stop.
        initializeSynthesizer()
        //The synthesizer has been initialized, no need to wait for utterance
        isWaitingForSpeak = false
    }


    func readAudioFileOrTTS(content : AudioContent){
        //Permet de lire les phrases au contenu statique en utilisant soit un fichier audio si disponible, soit la lecture par TTS.
        var name = ""
        switch resourceForTTS.pauseNavigation{
        case "french":
            switch content {
            case .start_navigation:
                name = "start_navigation_fr"
            case .start_navigation_static_firstpoint:
                playTTS(stringToPlay: resourceForTTS.startNavigationToStaticStartingPoint, priority: true)
            case .resume_navigation:
                name = "resume_smartrun_fr"
            case .pause_navigation:
                name = "pause_smartrun_fr"
            case .routeReached:
                playTTS(stringToPlay: resourceForTTS.routeReached, priority: true)
                return //We escape from function not to read AVAudioPlayer
            case .orientationChanged:
                playTTS(stringToPlay: resourceForTTS.inversionRoute, priority: true)
                return //We escape from function not to read AVAudioPlayer
            }
        case "english":
            switch content {
            case .start_navigation:
                name = "start_navigation_en"
            case .start_navigation_static_firstpoint:
                playTTS(stringToPlay: resourceForTTS.startNavigationToStaticStartingPoint, priority: true)
            case .resume_navigation:
                name = "resume_smartrun_en"
            case .pause_navigation:
                name = "pause_smartrun_en"
            case .routeReached:
                playTTS(stringToPlay: resourceForTTS.routeReached, priority: true)
            return //We escape from function not to read AVAudioPlayer
            case .orientationChanged:
                playTTS(stringToPlay: resourceForTTS.inversionRoute, priority: true)
                return //We escape from function not to read AVAudioPlayer
            }
        default:
            switch content {
            case .start_navigation:
                playTTS(stringToPlay: resourceForTTS.startNavigationToRoute, priority: true)
            case .start_navigation_static_firstpoint:
                playTTS(stringToPlay: resourceForTTS.startNavigationToStaticStartingPoint, priority: true)
            case .resume_navigation:
                playTTS(stringToPlay: resourceForTTS.resumeNavigation, priority: true)
            case .pause_navigation:
                playTTS(stringToPlay: resourceForTTS.pauseNavigation, priority: true)
            case .routeReached:
                playTTS(stringToPlay: resourceForTTS.routeReached, priority: true)
            case .orientationChanged:
                playTTS(stringToPlay: resourceForTTS.inversionRoute, priority: true)
            }
            return //We escape from function not to read AVAudioPlayer
        }
        if let soundURL = Bundle.main.url(forResource: name, withExtension: "mp3") {
            do {

                player = try AVAudioPlayer(contentsOf: soundURL)
                player.delegate = self
                if let thePlayer = player {
                    thePlayer.prepareToPlay()
                    thePlayer.play()

                   sendNotification(isPlaying: true)
                }
            }
            catch {
                print(error)
            }
        }

    }

    fileprivate func sendNotification(isPlaying : Bool) {
        let ttsSpeak:[String: Bool] = ["isPlaying": isPlaying]
       // NotificationCenter.default.post(name: Notification.Name(rawValue: notificationFromTTS), object: nil, userInfo: ttsSpeak)
    }
    /********************************/
    /******** Waiting timer *********/
    /********************************/

    func waitForSpeaking() {
        // We create a timer to watch if the the utterance has been triggered or not.
        // we set a boolean to know we are waiting the utterance to be played.
        //After a certain time, if the utterance has not been played, then we should reinit the TTS intance.
        isWaitingForSpeak = true
        if timerUterrance.isValid == false {
            timerUterrance = Timer.scheduledTimer(timeInterval: 0.5, target: self, selector: #selector(AudioService.lookForSpeakingUtterance), userInfo: nil, repeats: true)
        }
    }

    @objc func lookForSpeakingUtterance() {
        //Used to test if TTS is unable to speak. We reinit the instance if an utterance has not be spoken few times after the trigger
        timerCounter += 0.5
        if timerCounter > 6 && isWaitingForSpeak == true {
            //After timer countdown 6s and if we are still waiting the TTS to speak, then we should reinit the TTS
            NSLog("Synth asked to reinit")
            interruptionNeedToStop()
            if timerUterrance.isValid {
                timerUterrance.invalidate()
            }
            timerCounter = 0
        } else if isWaitingForSpeak == false {
            if timerUterrance.isValid {
                timerUterrance.invalidate()
            }
            timerCounter = 0
        }
    }
}


*/
