//
//  MyNavigationView+CLLocationManagerDelegate.swift
//  NavigationUI
//
//  Created by hassine othmane on 6/11/20.
//  Copyright © 2020 com.mile. All rights reserved.
//

import UIKit
import CoreLocation

import MapboxDirections
extension MyNavigationView :CLLocationManagerDelegate
{
    
    public func locationManager(_ manager: CLLocationManager, didUpdateLocations locations: [CLLocation]) {
        
        self.mapView_map.updateUserLocationAnnotationView()
        
        if startDate == nil {
            startDate = Date()
        } else {
           // print("elapsedTime:", String(format: "%.0fs", Date().timeIntervalSince(startDate)))
        }
        if startLocation == nil {
            startLocation = locations.first
        } else if let location = locations.last, lastLocation != nil  {
           // self.mapView_map.userCourseView
            updateGPS(position: location)
            
            if location.horizontalAccuracy  < 100
            {
                updateDistance(location:location)
                updateSpeed(location:location)
                
            }
        }
        if let location = locations.last ,  lastLocation == nil
        {
            if startLocation!.distance(from: location) < 50
            {
                lastLocation = locations.last
            }
        }
        else
        {
            lastLocation = locations.last
        }
        
        

        if isOfllineWayToRoute
        {
            if locations.last!.horizontalAccuracy  < 30
            {
                if let coordinates = myRoute?.shape?.coordinates
                {
                    for coordinate in coordinates {
                        if locations.last!.distance(from: CLLocation.init(latitude: coordinate.latitude, longitude: coordinate.longitude)) < 5 , self.calculatingRoute == false
                        {
                            self.calculatingRoute = true
                            stopNavigation()
                            let myLocation = LocationService.shared.getCurrentLocation()
                            if routeInformation?.isStartingPointStatic == false
                            {
                                routeCoordinates = MyUtils.changeBeginningOfSmartRunWithnearestPoint(routeCoordinates!, positionGPS: myLocation)
                            }
                            if let myCoordinate = myLocation?.coordinate
                            {
                                routeCoordinates?.insert(myCoordinate, at: 0)
                                if routeCoordinates!.count >= 100
                                {
                                    routeCoordinates!.removeLast()
                                }
                            }
                            DispatchQueue.main.asyncAfter(deadline: DispatchTime.now()+0.4) {
                                if let routeInformation = self.routeInformation
                                {
                                    PlayerManager.shared.playSynt(description: self.languageRessource.routeReached)
                                    if routeInformation.profileIdentifier == "walking"
                                    {
                                        self.isOfflinRoute = true
                                    self.presenter.calculateRouteOffline(points: self.routeCoordinates!, locale: self.languageAndCountry,measurementSystem: self.measurementSystem, objectFor: self, profileIdentifier: MBDirectionsProfileIdentifier.walking, firstCalculation: false, id: routeInformation.key)
                                        self.isOfllineWayToRoute = false
                                    } else if routeInformation.profileIdentifier == "cycling"
                                    {
                                        self.isOfflinRoute = true
                                        self.presenter.calculateRouteOffline(points: self.routeCoordinates!, locale: self.languageAndCountry,measurementSystem: self.measurementSystem, objectFor: self, profileIdentifier: MBDirectionsProfileIdentifier.walking, firstCalculation: false, id: routeInformation.key)
                                        self.isOfllineWayToRoute = false
                                    } else if routeInformation.profileIdentifier == "driving"
                                    {
                                        self.isOfflinRoute = true
                                        self.presenter.calculateRouteOffline(points: self.routeCoordinates!, locale: self.languageAndCountry,measurementSystem: self.measurementSystem, objectFor: self, profileIdentifier: MBDirectionsProfileIdentifier.automobile, firstCalculation: false, id: routeInformation.key)
                                        self.isOfllineWayToRoute = false
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }


        if wayToRoute == nil && lastCoordinateOffline != nil && isOfflinRoute == true
        {
            // you must check waypoints returned by calculate route
            let loc1 = CLLocation(latitude:  locations.last!.coordinate.latitude, longitude: locations.last!.coordinate.longitude)
            let loc2 = CLLocation(latitude: lastCoordinateOffline!.latitude, longitude: lastCoordinateOffline!.longitude)
            let distance = loc1.distance(from: loc2)
            if distance < 80
            {
                if runTime_seconds > 180
                {
                    stopMyNavigation()
                }
            }
        }
        
    }
    public func locationManager(_ manager: CLLocationManager, didFailWithError error: Error) {
        if (error as? CLError)?.code == .denied {
            manager.stopUpdatingLocation()
            manager.stopMonitoringSignificantLocationChanges()
        }
    }
    
}
