//
//  MyNavigationView+MyNavigationViewProtocol.swift
//  NavigationUI
//
//  Created by hassine othmane on 3/30/20.
//  Copyright © 2020 com.mile. All rights reserved.
//

import MapboxNavigation
import MapboxDirections
import MapboxCoreNavigation

import MapboxSpeech
import Speech


// MARK: - extending MyNavigationView to implement it's protocol
extension MyNavigationView: MyNavigationViewProtocol {
   
    
    
    
    func showDirectRouteToStartpoint() {
        isOfllineWayToRoute = true
        var coordinates : [CLLocationCoordinate2D] = [LocationService.shared.getCurrentLocation()!.coordinate,routeCoordinates!.first!]
        
        drawWayToRoute(coordinates: coordinates)
       // self.wayToRoute = route
        self.distanceWayToRoute = 0
        gpxForTest = coordinates
        animatePolyline(allCoordinates: coordinates)
        //initNavigation(userRoute: route, routeOptions: routeOptions)
        self.initRouteInformations()
        LocationService.shared.startUpdatelocation()
        LocationService.shared.locationManager.startMonitoringSignificantLocationChanges()
        DispatchQueue.main.asyncAfter(deadline: DispatchTime.now()+3) {
            

            if let routeInformation = self.routeInformation
            {
                if routeInformation.profileIdentifier == "walking"
                {
                    self.presenter.calculateRouteOffline(points: self.routeCoordinates!, locale: self.languageAndCountry,measurementSystem: self.measurementSystem, objectFor: self, profileIdentifier: MBDirectionsProfileIdentifier.walking, firstCalculation: true, id: routeInformation.key)
                } else if routeInformation.profileIdentifier == "cycling"
                {
                    self.presenter.calculateRouteOffline(points: self.routeCoordinates!, locale: self.languageAndCountry,measurementSystem: self.measurementSystem, objectFor: self, profileIdentifier: MBDirectionsProfileIdentifier.cycling, firstCalculation: true, id: routeInformation.key)
                } else if routeInformation.profileIdentifier == "driving"
                {
                    self.presenter.calculateRouteOffline(points: self.routeCoordinates!, locale: self.languageAndCountry,measurementSystem: self.measurementSystem, objectFor: self, profileIdentifier: MBDirectionsProfileIdentifier.automobile, firstCalculation: true, id: routeInformation.key)
                }
            }
        }
        
        
    }
    

    
    func set(user: MyUser) {
        self.user = user
    }
  
    
    func updateAndStartRoute(route: Route,routeOptions: RouteOptions, waypoints: [Waypoint]?) {
        removeLayerFromMap(withIdentifier: "polyline-dash")
        self.calculatingRoute = false
        if let coordinates = route.shape?.coordinates
        {
            self.myRoute = route
            self.myRouteOption = routeOptions
            self.distanceRoute = route.distance
            self.drawRoute(coordinates: coordinates)
            if let annotations = self.mapView_map.annotations
            {
                self.mapView_map.removeAnnotations(annotations)
            }
            self.gpxForTest?.append(contentsOf: coordinates)
            addPois()
            addSponsors()
            addSportSession()

            addDirectionals()
            printGpxTag()
            addFlags()
            DispatchQueue.main.asyncAfter(deadline: DispatchTime.now()+2) {
                self.initNavigation(userRoute: self.myRoute!, routeOptions: routeOptions)
            }
        }
    }
    
    
    func updateAndStartOfflineRoute(route: Route,routeOptions: RouteOptions, waypoints: [Waypoint]?) {
        removeLayerFromMap(withIdentifier: "polyline-dash")
        self.calculatingRoute = false
        if let coordinates = route.shape?.coordinates
        {
            
            var coordinates = MyUtils.changeBeginningOfSmartRunWithnearestPoint(coordinates, positionGPS: LocationService.shared.getCurrentLocation())
            coordinates.removeLast()
            self.myRoute = route
            self.myRouteOption = routeOptions
            self.distanceRoute = route.distance
            self.drawRoute(coordinates: coordinates)
            if let annotations = self.mapView_map.annotations
            {
                self.mapView_map.removeAnnotations(annotations)
            }
            self.gpxForTest?.append(contentsOf: coordinates)
            addPois()
            addSponsors()
            addSportSession()

            addDirectionals()
            printGpxTag()
            addFlagsOffline(first: coordinates.first!, last: coordinates.last!)
            DispatchQueue.main.asyncAfter(deadline: DispatchTime.now()+2) {
                self.initOfflineNavigation(userRoute: self.myRoute!, routeOptions: routeOptions)
            }
        }
    }
    
    func showRoute(route: Route,routeOptions: RouteOptions, waypoints:[Waypoint]?) {
        self.calculatingRoute = false
        if let coordinates = route.shape?.coordinates
        {
            self.myRoute = route
            self.myRouteOption = routeOptions
            self.distanceRoute = route.distance
            DispatchQueue.main.async {
                self.drawRoute(coordinates: coordinates)
            }
            self.gpxForTest?.append(contentsOf: coordinates)
            addPois()
            addSponsors()
            addSportSession()

            addDirectionals()
            printGpxTag()
            addFlags()
        }
    }
    
    
    
    func showOfflineRoute(route: Route, routeOptions: RouteOptions, waypoints: [Waypoint]?) {
           self.calculatingRoute = false
        
                  if let coordinates = route.shape?.coordinates
                  {
                    
                     var coordinates = MyUtils.changeBeginningOfSmartRunWithnearestPoint(coordinates, positionGPS: LocationService.shared.getCurrentLocation())
                    coordinates.removeLast()
                      self.myRoute = route
                      self.myRouteOption = routeOptions
                      self.distanceRoute = route.distance
                      DispatchQueue.main.async {
                          self.drawRoute(coordinates: coordinates)
                      }
                      self.gpxForTest?.append(contentsOf: coordinates)
                      addPois()
                      addSponsors()
                      addSportSession()
                      
                      addDirectionals()
                      printGpxTag()
                    addFlagsOffline(first: coordinates.first!, last: coordinates.last!)
                  }
       }
    
    func showAlertSystemMessage(title: String, message: String) {
        
    }
    
    func showRouteToStartpoint(route: Route,routeOptions: RouteOptions) {
        if let coordinates = route.shape?.coordinates
        {
            drawWayToRoute(coordinates: coordinates)
            self.wayToRoute = route
            self.distanceWayToRoute = route.distance
            gpxForTest = coordinates
            animatePolyline(allCoordinates: coordinates)
            initNavigation(userRoute: route, routeOptions: routeOptions)
            self.initRouteInformations()
            LocationService.shared.startUpdatelocation()
            LocationService.shared.locationManager.startMonitoringSignificantLocationChanges()
            flutterOnNavigationStarted()
            DispatchQueue.main.asyncAfter(deadline: DispatchTime.now()+3) {
                

                if let routeInformation = self.routeInformation
                {
                    if routeInformation.profileIdentifier == "walking"
                    {
                        self.presenter.calculateRoute(points: self.routeCoordinates!, locale: self.languageAndCountry,measurementSystem: self.measurementSystem, objectFor: self, profileIdentifier: MBDirectionsProfileIdentifier.walking, firstCalculation: true)
                    } else if routeInformation.profileIdentifier == "cycling"
                    {
                        self.presenter.calculateRoute(points: self.routeCoordinates!, locale: self.languageAndCountry,measurementSystem: self.measurementSystem, objectFor: self, profileIdentifier: MBDirectionsProfileIdentifier.cycling, firstCalculation: true)
                    } else if routeInformation.profileIdentifier == "driving"
                    {
                        self.presenter.calculateRoute(points: self.routeCoordinates!, locale: self.languageAndCountry,measurementSystem: self.measurementSystem, objectFor: self, profileIdentifier: MBDirectionsProfileIdentifier.automobile, firstCalculation: true)
                    }
                }
            }
        }
    }
}
