//
//  PlayerManager.swift
//  MyThalassa
//
//  Created by Hassine on 09/10/2019.
//  Copyright © 2019 mile. All rights reserved.
//

import Foundation
import AVFoundation
import MapboxCoreNavigation



class PlayerManager:NSObject {

    var arrayStringPOIQueue:        Array<String> = []
    static let shared = PlayerManager()
    var audioPlayer: AVAudioPlayer?
    //  var audioPlayerPoiDescription: AVAudioPlayer?
    var audioPlayerPoiDescriptionQueue: AVQueuePlayer?
    var audioPlayerDirectional: AVAudioPlayer?
   // var delegate : PlayerManagerDelegate? = nil
    var timer : Timer? = nil

    var aVSpeechSynthesisVoice : AVSpeechSynthesisVoice!
    var speechUtterance: AVSpeechUtterance!
    var speechSynthesizer = AVSpeechSynthesizer()
    var theSession  = AVAudioSession()
    var askToDeactivateSession = false

    func configureSession(lang:String) {
        arrayStringPOIQueue.removeAll()
        theSession = AVAudioSession.sharedInstance()
        speechSynthesizer.delegate = self
        aVSpeechSynthesisVoice = AVSpeechSynthesisVoice.init(language: lang)
        let voices = AVSpeechSynthesisVoice.speechVoices()
        var _: AVSpeechSynthesisVoice?
       
        for voice in voices {
            //print(voice)
            if  voice.quality == .enhanced && voice.language == lang {
                aVSpeechSynthesisVoice = voice
            }
        }
        speechUtterance = AVSpeechUtterance.init()
        speechUtterance.rate = 0.51
        speechUtterance.voice = aVSpeechSynthesisVoice
        speechUtterance.volume = 1
        volume = 1
        NavigationSettings.shared.voiceMuted = false


    }
    var volume:Float = 1


    func playSyntDirectionnal(description:String)
    {



        if speechSynthesizer.isSpeaking
        {
            speechSynthesizer.stopSpeaking(at: .immediate)
            arrayStringPOIQueue.insert(description, at: 0)
            arrayStringPOIQueue.insert("", at: 1)
            arrayStringPOIQueue.insert(lastDescription!, at: 2)
            lastDescription = String(arrayStringPOIQueue.first!)




            self.speechUtterance = AVSpeechUtterance(string: String( self.arrayStringPOIQueue.first!))
            self.speechUtterance.rate = 0.51
            self.speechUtterance.voice = self.aVSpeechSynthesisVoice
            self.speechUtterance.volume = self.volume
            print("speechSynthesizer.speak 4 \(self.speechUtterance.description)")
            self.speechSynthesizer.speak(self.speechUtterance)
            self.arrayStringPOIQueue.remove(at: 0)


        }
        else

        {

            arrayStringPOIQueue.insert(description, at: 0)
            arrayStringPOIQueue.insert("", at: 1)
            lastDescription = String(arrayStringPOIQueue.first!)

            self.speechUtterance = AVSpeechUtterance(string: String( self.arrayStringPOIQueue.first!))
            self.speechUtterance.rate = 0.51
            self.speechUtterance.voice = self.aVSpeechSynthesisVoice
            self.speechUtterance.volume = self.volume
            print("speechSynthesizer.speak 4 \(self.speechUtterance.description)")
            self.speechSynthesizer.speak(self.speechUtterance)
            self.arrayStringPOIQueue.remove(at: 0)

        
        }





     
    }


    func playSynt(description:String)
    {


        let descriptions = description.trimmingCharacters(in: .whitespacesAndNewlines).split(separator: ".")

        if descriptions.count > 0
        {


        if speechSynthesizer.isSpeaking
        {

            for d in descriptions
            {
                arrayStringPOIQueue.append(String(d)+" .")
            }
            arrayStringPOIQueue.append("")
        }
        else if speechSynthesizer.isPaused
        {
            for d in descriptions
                       {
                           arrayStringPOIQueue.append(String(d)+" .")
                       }
            arrayStringPOIQueue.append("")
            continueSpeaking()
        }
        else
        {


            do {
                       try duckAudio()
                   } catch {
                      print("error")
                   }

                for d in descriptions
                           {
                               arrayStringPOIQueue.append(String(d)+" .")
                           }
                arrayStringPOIQueue.append("")

            lastDescription = String(arrayStringPOIQueue.first!)
            speechUtterance = AVSpeechUtterance(string: String(arrayStringPOIQueue.first!))
                  speechUtterance.rate = 0.51
                  speechUtterance.voice = aVSpeechSynthesisVoice
                 speechUtterance.volume = volume

            print("speechSynthesizer.speak 1 \(speechUtterance.description)")
            speechSynthesizer.speak(speechUtterance)
             self.arrayStringPOIQueue.remove(at: 0)
            print("remove = 2\(self.arrayStringPOIQueue)")
        }
        }
        
    }

    func stopSynt() -> Void {

        if speechSynthesizer.isSpeaking {
            speechSynthesizer.stopSpeaking(at: .immediate)

        }
    }

   func stopSpeaking(){
        if speechSynthesizer.isSpeaking {
            speechSynthesizer.stopSpeaking(at: .immediate)
        }
    arrayStringPOIQueue.removeAll()
    }

    func speak() -> Void {
        if speechSynthesizer.isPaused == true ||  speechSynthesizer.isSpeaking == false
        {
        speechUtterance = AVSpeechUtterance(string: self.arrayStringPOIQueue.first!)
              speechUtterance.rate = 0.51
              speechUtterance.voice = aVSpeechSynthesisVoice
             speechUtterance.volume = volume
         print("speechSynthesizer.speak 2 \(speechUtterance.description)")
         speechSynthesizer.speak(speechUtterance)
        }
    }

    func continueSpeaking() -> Void {

        print(speechUtterance.speechString)
        if speechSynthesizer.isPaused == true
        {
            isContinue = true
        if lastDescription != ""
        {


            speechSynthesizer.stopSpeaking(at: .immediate)

            speechUtterance = AVSpeechUtterance(string: String( lastDescription!))
                  speechUtterance.rate = 0.51
                  speechUtterance.voice = aVSpeechSynthesisVoice
                 speechUtterance.volume = volume
             print("speechSynthesizer.speak 3 \(speechUtterance.description)")
             speechSynthesizer.speak(speechUtterance)
        }
        else
        {


             //   if let des = self.arrayStringPOIQueue.first
             //   {
            //      self.arrayStringPOIQueue.remove(at: 0)
               //     print("remove = 3\(self.arrayStringPOIQueue)")
          //  lastDescription = des

            speechSynthesizer.stopSpeaking(at: .immediate)

            speechUtterance = AVSpeechUtterance(string: String( lastDescription!))
                  speechUtterance.rate = 0.51
                  speechUtterance.voice = aVSpeechSynthesisVoice
                 speechUtterance.volume = volume
             print("speechSynthesizer.speak 4 \(speechUtterance.description)")
             speechSynthesizer.speak(speechUtterance)

        //    }

        }
        }
    }


    var isContinue = false
    var lastDescription:String?

}

extension PlayerManager:AVSpeechSynthesizerDelegate
{


    func duckAudio() throws {
        let audioSession = AVAudioSession.sharedInstance()
        if #available(iOS 12.0, *) {
            try audioSession.setCategory(.playback, mode: .voicePrompt, options: [.duckOthers, .mixWithOthers])
        } else {
            try audioSession.setCategory(.ambient, mode: .spokenAudio, options: [.duckOthers, .mixWithOthers])
        }
        try audioSession.setActive(true)
    }

    func mixAudio() throws {
        let audioSession = AVAudioSession.sharedInstance()
        try audioSession.setCategory(.ambient, mode: audioSession.mode)
        try audioSession.setActive(true)
    }

    func unDuckAudio() throws {
        try AVAudioSession.sharedInstance().setActive(false, options: [.notifyOthersOnDeactivation])
    }






    public func speechSynthesizer(_ synthesizer: AVSpeechSynthesizer, didStart utterance: AVSpeechUtterance) {
        print("AVSpeechSynthesizerDelegate: didStart")
    }

    public func speechSynthesizer(_ synthesizer: AVSpeechSynthesizer, didFinish utterance: AVSpeechUtterance) {
        print("AVSpeechSynthesizerDelegate: didFinish\(utterance.speechString)")
        NotificationCenter.default.post(name:NSNotification.Name("initTimerSmartFact"),object: nil)
        if arrayStringPOIQueue.count > 0  && isContinue == false
        {
            print("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n")
            print("array = \n\(self.arrayStringPOIQueue)")
            if self.arrayStringPOIQueue.first! == ""
            {



                DispatchQueue.main.asyncAfter(deadline: DispatchTime.now()+1) {
                    if  self.arrayStringPOIQueue.count > 0
                    {
                    self.arrayStringPOIQueue.remove(at: 0)
                    print("remove = 4\(self.arrayStringPOIQueue)")
                    if self.arrayStringPOIQueue.count > 0
                    {
                        self.lastDescription = self.arrayStringPOIQueue.first!
                        self.speak()
                        self.arrayStringPOIQueue.remove(at: 0)
                       
                    }
                    }
                }
            }
            else
            {
                lastDescription = self.arrayStringPOIQueue.first!

                DispatchQueue.main.asyncAfter(deadline: DispatchTime.now()) {

                     self.speak()
                    self.arrayStringPOIQueue.remove(at: 0)
                     print("remove = 1\(self.arrayStringPOIQueue)")
                }
            }

        }
        else
        {
            do {
                      try unDuckAudio()
                  } catch {
                    print("error stop session")
                  }
        }
       isContinue = false
    }


    public func speechSynthesizer(_ synthesizer: AVSpeechSynthesizer, didPause utterance: AVSpeechUtterance) {
        print("AVSpeechSynthesizerDelegate: didPause")
    }

    public func speechSynthesizer(_ synthesizer: AVSpeechSynthesizer, didContinue utterance: AVSpeechUtterance) {
        print("AVSpeechSynthesizerDelegate: didContinue")
    }

    public func speechSynthesizer(_ synthesizer: AVSpeechSynthesizer, didCancel utterance: AVSpeechUtterance) {
        print("AVSpeechSynthesizerDelegate: didCancel")
    }

    public func speechSynthesizer(_ synthesizer: AVSpeechSynthesizer, willSpeakRangeOfSpeechString characterRange: NSRange, utterance: AVSpeechUtterance) {
        // This callback can be used with NSAttributedString if current text has to be highlighted.
        let subString = (utterance.speechString as NSString).substring(with: characterRange)
        if subString == "."
        {
            isContinue = false
        }
      // print("AVSpeechSynthesizerDelegate: willSpeakRangeOfSpeechString with \(characterRange); text: \(subString)")
    }

}

