//
//  UIButton+Extension.swift
//  Utils
//
//  Created by Hassine on 12/02/2020.
//  Copyright © 2020 com.mile. All rights reserved.
//

import Foundation
import UIKit



extension UIButton
{
    
    public func primaryStyle() -> Void {
        DispatchQueue.main.async {
            self.backgroundColor = Style.shared.primaryColor
            self.titleLabel!.font = Style.shared.btnPrimaryFont
            self.setTitleColor(UIColor.white, for: .normal)
            self.layer.cornerRadius = Style.shared.btnCornerRaduis
        }
    }

    public func primaryStyle(color : UIColor) -> Void {
           DispatchQueue.main.async {
               self.backgroundColor = color
               self.titleLabel!.font = Style.shared.btnPrimaryFont
               self.setTitleColor(UIColor.white, for: .normal)
               self.layer.cornerRadius = Style.shared.btnCornerRaduis
           }
       }

    public func primaryStyle(cornerRadius: CGFloat) -> Void {
        DispatchQueue.main.async {
            self.backgroundColor = Style.shared.primaryColor
            self.titleLabel!.font = Style.shared.btnPrimaryFont
            self.setTitleColor(UIColor.white, for: .normal)
            self.layer.cornerRadius = cornerRadius
        }
    }

    public func primaryStyle(cornerRadius: CGFloat,font : UIFont) -> Void {
        DispatchQueue.main.async {
            self.backgroundColor = Style.shared.primaryColor
            self.titleLabel!.font = font
            self.setTitleColor(UIColor.white, for: .normal)
            self.layer.cornerRadius = cornerRadius
        }
    }

    public func primaryStyle(cornerRadius: CGFloat, color:UIColor,font : UIFont) -> Void {
        DispatchQueue.main.async {
            self.backgroundColor = color
            self.titleLabel!.font = font
            self.setTitleColor(UIColor.white, for: .normal)
            self.layer.cornerRadius = cornerRadius
        }
    }
    
    public func secondaryStyle() -> Void {
        DispatchQueue.main.async {
            self.backgroundColor = Style.shared.accentColor
            self.titleLabel!.font = Style.shared.btnSecondaryFont
            self.setTitleColor(UIColor.white, for: .normal)
            self.layer.cornerRadius = Style.shared.btnCornerRaduis
            
        }
    }
    
    public func tertiaryStyle() -> Void {
        DispatchQueue.main.async {
            self.backgroundColor = UIColor.white
            self.titleLabel!.font = Style.shared.btnPrimaryFont
            self.setTitleColor(Style.shared.primaryColor, for: .normal)
            self.layer.cornerRadius = Style.shared.btnCornerRaduis
        }
    }

    public func tertiaryStyle(color : UIColor) -> Void {
        DispatchQueue.main.async {
            self.backgroundColor = color
            self.titleLabel!.font = Style.shared.btnPrimaryFont
            self.setTitleColor(Style.shared.primaryColor, for: .normal)
            self.layer.cornerRadius = Style.shared.btnCornerRaduis
        }
    }

    public func clearStyle() -> Void {
        DispatchQueue.main.async {
            self.backgroundColor = UIColor.clear
            self.titleLabel!.font = Style.shared.btnPrimaryFont
            self.setTitleColor(Style.shared.accentColor, for: .normal)
            self.layer.cornerRadius = Style.shared.btnCornerRaduis
        }
    }

    public func clearStyle(textColor : UIColor) -> Void {
        DispatchQueue.main.async {
            self.backgroundColor = UIColor.clear
            self.titleLabel!.font = Style.shared.btnPrimaryFont
            self.setTitleColor(textColor, for: .normal)
            self.layer.cornerRadius = Style.shared.btnCornerRaduis
        }
    }

    public func clearStyle2(textColor : UIColor) -> Void {
        DispatchQueue.main.async {
            self.backgroundColor = UIColor.clear
            self.titleLabel!.font = Style.shared.btnSecondaryFont
            self.setTitleColor(textColor, for: .normal)
            self.layer.cornerRadius = Style.shared.btnCornerRaduis
        }
    }
    
    public func primaryTextStyle() -> Void {
        DispatchQueue.main.async {
            self.titleLabel!.font =  Style.shared.btnFont
            self.setTitleColor(Style.shared.primaryColor, for: .normal)
        }
    }
    
    
    public func secondaryTextStyle() -> Void {
        DispatchQueue.main.async {
            self.titleLabel!.font =  Style.shared.btnFont
            self.setTitleColor(Style.shared.accentColor, for: .normal)
        }
    }
    
    public func backStyle() -> Void {
        DispatchQueue.main.async {
            self.backgroundColor = UIColor.white
            self.layer.cornerRadius = self.frame.width/2
            self.setTitle("", for: UIControl.State.normal)
            self.setImage(UIImage.init(named: "CommonIcons/back_ic"), for: UIControl.State.normal)
            self.tintColor = Style.shared.accentColor
        }
    }
    
    public func closeStyle() -> Void {
        DispatchQueue.main.async {
            self.backgroundColor = UIColor.white
            self.setTitle("", for: UIControl.State.normal)
            self.setImage(UIImage.init(named: "CommonIcons/close_ic"), for: UIControl.State.normal)
            self.tintColor = Style.shared.accentColor
            
        }
    }
    
    
    public func goStyle() -> Void {
        DispatchQueue.main.async {
            self.backgroundColor = Style.shared.primaryColor
            //self.setTitle("GO", for: UIControl.State.normal)
            self.titleLabel!.font =  Style.shared.btnFloatFont
            self.tintColor = UIColor.white
            self.layer.cornerRadius = Style.shared.btnCornerRaduis
            
        }
    }
    
    
}

