//
//  UILabel+Extension.swift
//  MyThalassa
//
//  Created by hassine othmane on 9/15/19.
//  Copyright © 2019 mile. All rights reserved.
//

import Foundation
import UIKit


extension UILabel
{
    public func textBodyStyle() -> Void {

        self.font = Style.shared.bodyFont
        self.textColor = Style.shared.textBodyColor
        let attributedString = NSMutableAttributedString(string: self.text ?? "")
        let paragraphStyle = NSMutableParagraphStyle()
        paragraphStyle.lineSpacing = 5
        paragraphStyle.alignment = .left
        attributedString.addAttribute(NSAttributedString.Key.paragraphStyle, value:paragraphStyle, range:NSMakeRange(0, attributedString.length))
        self.attributedText = attributedString
    }


    public func textBodyStyle(color:UIColor) -> Void {

        self.font = Style.shared.bodyFont
        self.textColor = color
        let attributedString = NSMutableAttributedString(string: self.text ?? "")
        let paragraphStyle = NSMutableParagraphStyle()
        paragraphStyle.lineSpacing = 5
        paragraphStyle.alignment = .left
        attributedString.addAttribute(NSAttributedString.Key.paragraphStyle, value:paragraphStyle, range:NSMakeRange(0, attributedString.length))
        self.attributedText = attributedString
    }

    public func textBodyStyle(alignment: NSTextAlignment) -> Void {

        self.font = Style.shared.bodyFont
        self.textColor = Style.shared.textBodyColor
        let attributedString = NSMutableAttributedString(string: self.text ?? "")
        let paragraphStyle = NSMutableParagraphStyle()
        paragraphStyle.lineSpacing = 3
        paragraphStyle.alignment = alignment
        attributedString.addAttribute(NSAttributedString.Key.paragraphStyle, value:paragraphStyle, range:NSMakeRange(0, attributedString.length))
        self.attributedText = attributedString
    }
    
    
    public func textBodyMediumStyle() -> Void {

        self.font = Style.shared.bodyMediumFont
        self.textColor = Style.shared.textBodyColor
        let attributedString = NSMutableAttributedString(string: self.text ?? "")
        let paragraphStyle = NSMutableParagraphStyle()
        paragraphStyle.lineSpacing = 3
        paragraphStyle.alignment = .left
        attributedString.addAttribute(NSAttributedString.Key.paragraphStyle, value:paragraphStyle, range:NSMakeRange(0, attributedString.length))
        self.attributedText = attributedString
    }

    public func headerStyle() -> Void {
        self.font = Style.shared.headerFont
        self.textColor = Style.shared.titleColor
    }

    public func headerStyle(color:UIColor) -> Void {
        self.font = Style.shared.headerFont
        self.textColor = color
    }



    public func title1Style() -> Void {
        self.font = Style.shared.title1Font
        self.textColor = Style.shared.titleColor
    }

    public func title1Style(color:UIColor) -> Void {
        self.font = Style.shared.title1Font
        self.textColor = color
    }

    public func title2Style() -> Void {
        self.font = Style.shared.title2Font
        self.textColor = Style.shared.titleColor
    }

    public func title2Style(color:UIColor) -> Void {
           self.font = Style.shared.title2Font
           self.textColor = color
    }

    public func title3Style() -> Void {
        self.font = Style.shared.title3Font
        self.textColor = Style.shared.titleColor
    }

    public func grayStyle(color:UIColor) -> Void {
           self.font = Style.shared.normalFont
           self.textColor = color
    }

    public func customStyle(font:UIFont,color:UIColor) -> Void {
           self.font = font
           self.textColor = color
    }

    public func titleWebPageStyle() -> Void {
           self.font = UIFont.init(name: "Gilroy-Semibold", size: 15.0)
           self.textColor = Style.shared.titleColor
       }

    public func progressTimeStyle() -> Void {
        self.font = UIFont.init(name: "Gilroy-Semibold", size: 14.0)
        self.textColor = UIColor(red:0.96, green:0.64, blue:0.19, alpha:1.0)
    }

    public func titleCardStyle() -> Void {
        self.font = UIFont.init(name: "Gilroy-Semibold", size: 14.0)
        self.textColor = UIColor.white
    }
    
    
    public func bodyCardStyle() -> Void {
        self.font = UIFont.init(name: "Gilroy-Bold", size: 20.0)
        self.textColor = UIColor.white
    }

    public func titleNavigationCard() -> Void {
        self.font = UIFont.init(name: "Gilroy-Medium", size: 12.0)
        self.textColor = UIColor(red:0.56, green:0.56, blue:0.58, alpha:1.0)
    }
    
    public func titleStatistics() -> Void {
        self.font = UIFont.init(name: "Gilroy-Medium", size: 14.0)
        self.textColor = UIColor(red:0.56, green:0.56, blue:0.58, alpha:1.0)
    }

    public func valueNavigationCard() -> Void {
        self.font = UIFont.init(name: "Gilroy-Medium", size: 16.0)
        self.textColor = UIColor.white
       }
    
    public func valueStatistics() -> Void {
     self.font = UIFont.init(name: "Gilroy-Medium", size: 14.0)
        self.textColor = Style.shared.primaryColor
    }

    public func lightStyle(color:UIColor) -> Void {
        self.font = Style.shared.title4Font
        self.textColor = color
    }

    public func titleDestinationStyle() -> Void {
        self.font = UIFont.init(name: "Gilroy-Bold", size: 50.0)
        self.textColor = UIColor.white
    }

    public func titleDestinationCradStyle() -> Void {
          self.font = UIFont.init(name: "Gilroy-Bold", size: 18.0)
          self.textColor = UIColor.white
      }
    
    public func titleRouteCradStyle() -> Void {
        self.font = UIFont.init(name: "Gilroy-Semibold", size: 16.0)
        self.textColor = UIColor.white
    }
    
    public func detailRouteCradStyle() -> Void {
        self.font = UIFont.init(name: "Gilroy-Semibold", size: 12.0)
        self.textColor = UIColor.white
     }


    // MARK: MyNavigationViewUI Delegate -

    public func timerCradStyle() -> Void {
        self.font = Style.shared.timerCardFont
        self.textColor = Style.shared.timerCardColor
    }

    public func valueCradStyle() -> Void {
        self.font = Style.shared.valuesCardFont
        self.textColor = Style.shared.textCardColor
    }

    public func titleCradStyle() -> Void {
        self.font = Style.shared.titleCardFont
        self.textColor = Style.shared.textCardColor
    }



    public func countLabelLines() -> Int {
        // Call self.layoutIfNeeded() if your view uses auto layout
        let myText = self.text! as NSString

        let rect = CGSize(width: self.bounds.width, height: CGFloat.greatestFiniteMagnitude)
        let labelSize = myText.boundingRect(with: rect, options: .usesLineFragmentOrigin, attributes: [NSAttributedString.Key.font: self.font!], context: nil)
            return Int(ceil(CGFloat(labelSize.height) / self.font.lineHeight))


    }

    public func distanceInstructionStyle() -> Void {
              self.font = Style.shared.distanceInstructionFont
           self.textColor = UIColor.white
       }

       public func primaryInstructionStyle() -> Void {
        self.font = Style.shared.primaryInstructionFont
              self.textColor = UIColor.white
          }

}

extension UITextView
{

    public func textBodyStyle() -> Void {

        self.font = Style.shared.bodyFont
        self.textColor = Style.shared.textBodyColor
        self.isEditable = false
        
        
        let attributedString = NSMutableAttributedString(string: self.text!)
        let paragraphStyle = NSMutableParagraphStyle()
        paragraphStyle.lineSpacing = 3
        paragraphStyle.alignment = .left
        self.isEditable = false
        self.showsVerticalScrollIndicator = false
        attributedString.addAttribute(NSAttributedString.Key.paragraphStyle, value:paragraphStyle, range:NSMakeRange(0, attributedString.length))
        self.attributedText = attributedString
        self.backgroundColor = .clear
    }
    





}

//var title1Font =
extension UITextField
{

    public func title2Style() -> Void {
           self.font = UIFont(name: "GothamRounded-Medium", size: 16)
           self.textColor = Style.shared.titleColor
    }


    public func title1Style() -> Void {
              self.font = UIFont(name: "GothamRounded-Medium", size: 18)
              self.textColor = Style.shared.titleColor
       }
}
