//
//  MyStyle.swift
//  v4_navigation_engine
//
//  Created by Lionel Malloggi on 19/06/2020.
//

import Foundation
import UIKit


struct MyStyle : StyleProtocol   {


    var grayColor = UIColor(red:0.44, green:0.49, blue:0.54, alpha:1.00)



    var distanceInstructionFont = UIFont(name: "GothamRounded-Medium", size: 45)

    var primaryInstructionFont = UIFont(name: "GothamRounded-Medium", size: 28)



    var textCardColor  =  UIColor.init(named: "textCardColor")! // #1E1E1E

    var timerCardColor = UIColor(red:0.95, green:0.35, blue:0.32, alpha:1.00); // F25A51

    var timerCardFont = UIFont(name: "GothamRounded-Medium", size: 30)

    var valuesCardFont = UIFont(name: "GothamRounded-Bold", size: 22)

    var titleCardFont = UIFont(name: "GothamRounded-Medium", size: 14)

    var slideBackgroundColor = UIColor(red:0.94, green:0.94, blue:0.94, alpha:1.00);

    var slideDotColor       = UIColor(red:0.07, green:0.15, blue:0.23, alpha:1.00);

    var slideDotBorderColor = UIColor(red:0.59, green:0.59, blue:0.59, alpha:1.00);


    var headerFont = UIFont(name: "GothamRounded-Medium", size: 30)

    var title1Font = UIFont(name: "GothamRounded-Medium", size: 18)

    var title2Font = UIFont(name: "GothamRounded-Bold", size: 16)

    var title3Font = UIFont(name: "GothamRounded-Bold", size: 14)

    var title4Font = UIFont(name: "GothamRounded-Light", size: 12)

    var bodyFont = UIFont(name: "GothamRounded-Light", size: 14)

    var bodyMediumFont = UIFont(name: "GothamRounded-Medium", size: 14)

    var normalFont = UIFont(name: "GothamRounded-Medium", size: 13)

    var captionFont = UIFont(name: "GothamRounded-Bold", size: 12)

    var btnPrimaryFont = UIFont(name: "GothamRounded-Medium", size: 16)

    var btnSecondaryFont = UIFont(name: "GothamRounded-Medium", size: 16)

    var btnTertiaryFont = UIFont(name: "GothamRounded-Medium", size: 14)

    var btnFloatFont = UIFont(name: "GothamRounded-Medium", size: 22)

    var btnFont = UIFont(name: "GothamRounded-Bold", size: 14)

    var backgroundColor = UIColor.init(named: "BackgroundColor") ?? UIColor.white

    var grayBackgroundColor  = UIColor.white

    var primaryColor         = UIColor(red:0.34, green:0.77, blue:0.16, alpha:1.0) // 57C528

    var primaryColorDisabled = UIColor(red:0.36, green:0.51, blue:0.63, alpha:0.8) // 5B83A0

    var accentColor          = UIColor(red:0.07, green:0.15, blue:0.23, alpha:1.00) // 12263B

    var titleColor           = UIColor.init(named: "TitleColor") ?? UIColor.black // 12263B

    var textBodyColor        = UIColor.init(named: "textBodyColor") ?? UIColor.black// 5f6c78

    var textBodyAccentColor  = UIColor(red:0.37, green:0.42, blue:0.47, alpha:1.0) // 5f6c78

    var cardColor            = UIColor(red:0.14, green:0.16, blue:0.22, alpha:1.0) // 3B414F

    var cardShadowColor      = UIColor(red:0.14, green:0.15, blue:0.20, alpha:1.0) // 242633

    var progressTintColor    = UIColor(red:0.80, green:0.80, blue:0.80, alpha:1.0) // CBCBCB

    var progressBackColor    = UIColor(red:0.96, green:0.96, blue:0.96, alpha:1.0) // F6F6F6

    var greenColor           = UIColor(red:0.15, green:0.68, blue:0.38, alpha:1.0) // 27AE60

    var redColor             = UIColor(red:0.75, green:0.22, blue:0.17, alpha:1.0) //

    var btnCornerRaduis: CGFloat = 30

    public static let shared = MyStyle()



    func configurator() -> Void {
        Style.shared.backgroundColor = backgroundColor
        Style.shared.grayBackgroundColor = grayBackgroundColor
        Style.shared.primaryColor = primaryColor
        Style.shared.primaryColorDisabled = primaryColorDisabled
        Style.shared.accentColor = accentColor
        Style.shared.titleColor = titleColor
        Style.shared.textBodyColor = textBodyColor
        Style.shared.textBodyAccentColor = textBodyAccentColor
        Style.shared.cardColor = cardColor
        Style.shared.cardShadowColor = cardShadowColor
        Style.shared.progressTintColor = progressTintColor
        Style.shared.progressBackColor = progressBackColor
        Style.shared.btnCornerRaduis = btnCornerRaduis
        Style.shared.headerFont = headerFont
        Style.shared.title1Font = title1Font
        Style.shared.title2Font = title2Font
        Style.shared.title3Font = title3Font
        Style.shared.title4Font = title4Font
        Style.shared.bodyFont = bodyFont
        Style.shared.bodyMediumFont = bodyMediumFont
        Style.shared.captionFont = captionFont
        Style.shared.btnPrimaryFont = btnPrimaryFont
        Style.shared.btnSecondaryFont = btnSecondaryFont
        Style.shared.btnTertiaryFont = btnTertiaryFont
        Style.shared.btnFont = btnFont
        Style.shared.btnFloatFont = btnFloatFont





        Style.shared.slideDotBorderColor = slideDotBorderColor
        Style.shared.slideDotColor = slideDotColor
        Style.shared.slideBackgroundColor = slideBackgroundColor
        Style.shared.primaryInstructionFont = primaryInstructionFont
        Style.shared.distanceInstructionFont = distanceInstructionFont
        Style.shared.grayColor = grayColor


        Style.shared.textCardColor = textCardColor
         Style.shared.valuesCardFont = valuesCardFont
         Style.shared.titleCardFont = titleCardFont




    }




}



