//
//  MyUtils.swift
//  NavigationUI
//
//  Created by Hassine on 17/06/2020.
//  Copyright © 2020 com.mile. All rights reserved.
//

import Foundation
import CoreLocation


public class MyUtils {



    public static func secondsToHoursMinutesSeconds (seconds : Double) -> (Double, Double, Double) {
        let (hr,  minf) = modf (seconds / 3600)
        let (min, secf) = modf (60 * minf)
        return (hr, min, 60 * secf)
    }





    public static func getPreferredLocale() -> Locale {
        guard let preferredIdentifier = Locale.preferredLanguages.first else {
            return Locale.current
        }
        return Locale(identifier: preferredIdentifier)
    }

    public static func getLanguageISO() -> String {
        let locale = getPreferredLocale()
        guard let languageCode = locale.languageCode else {
            return "en"
        }
        return languageCode
    }

    public static func getLanguage() -> String {
        let locale = getPreferredLocale()
        guard let languageCode = locale.languageCode else {
            return "en"
        }
        return languageCode.uppercased()
    }


    public static func getPoiLanguage(en:String?,fr:String?,es:String?,it:String?,de:String?,nl:String?,pt:String?) -> String {


        if  let arraySaved = UserDefaults.standard.array(forKey: "languagePreferredOrderV4") as! Array<String>? {
            for language in arraySaved
            {
                if language == "EN" && en != nil
                {
                    return "en-US"
                }
                else if language == "FR" && fr != nil
                {
                   return "fr-FR"
                }
                else if language == "ES" && es != nil
                {
                     return "es-ES"
                }
                else if language == "IT" && it != nil
                {
                    return "it-IT"
                }
                else if language == "DE" && de != nil
                {
                     return "de-DE"
                }
                else if language == "NL" && nl != nil
                {
                     return "nl-NL"
                }
                else if language == "PT" && pt != nil
                {
                   return "pt-PT"
                }
            }


        }
        else {

            let language = MyUtils.getLanguage()
           if language == "EN" && en != nil
           {
               return "en-US"
           }
           else if language == "FR" && fr != nil
           {
              return "fr-FR"
           }
           else if language == "ES" && es != nil
           {
                return "es-ES"
           }
           else if language == "IT" && it != nil
           {
               return "it-IT"
           }
           else if language == "DE" && de != nil
           {
                return "de-DE"
           }
           else if language == "NL" && nl != nil
           {
                return "nl-NL"
           }
           else if language == "PT" && pt != nil
           {
              return "pt-PT"
           }

        }


        return "en-US"
    }


    public static func translateToSelectedLanguage(descriptions:[String: String]) -> String? {

       if  let arraySaved = UserDefaults.standard.array(forKey: "languagePreferredOrderV4") as! Array<String>? {
                  for language in arraySaved
                  {
                    if let description = descriptions[language]
                    {
                        return description
                    }

                }




        } else
       {

         let language = MyUtils.getLanguage()
                if let description = descriptions[language]
                {
                    return description
                }

        }
          return nil
    }

    public static func translateToSelectedLanguage(en:String?,fr:String?,es:String?,it:String?,de:String?,nl:String?,pt:String?) -> String? {

        if  let arraySaved = UserDefaults.standard.array(forKey: "languagePreferredOrderV4") as! Array<String>? {
            for language in arraySaved
            {
                if language == "EN" && en != nil
                {
                    return en!
                }
                else if language == "FR" && fr != nil
                {
                    return fr!
                }
                else if language == "ES" && es != nil
                {
                    return es!
                }
                else if language == "IT" && it != nil
                {
                    return it!
                }
                else if language == "DE" && de != nil
                {
                    return de!
                }
                else if language == "NL" && nl != nil
                {
                    return nl!
                }
                else if language == "PT" && pt != nil
                {
                    return pt!
                }
            }


        }
        else {

            let language = MyUtils.getLanguage()
            if language == "EN" && en != nil
            {
                return en!
            }
            else if language == "FR" && fr != nil
            {
                return fr!
            }
            else if language == "ES" && es != nil
            {
                return es!
            }
            else if language == "IT" && it != nil
            {
                return it!
            }
            else if language == "DE" && de != nil
            {
                return de!
            }
            else if language == "NL" && nl != nil
            {
                return nl!
            }
            else if language == "PT" && pt != nil
            {
                return pt!
            }

            else if en != nil
            {
                return en!
            }
            else if fr != nil
            {
                return fr!
            }
        }


        return nil
    }



    public static func translate2ToSelectedLanguage(en:String?,fr:String?,es:String?,it:String?,de:String?,nl:String?,pt:String?) -> String? {

        if  let arraySaved = UserDefaults.standard.array(forKey: "languagePreferredOrderV4") as! Array<String>? {
            let language = arraySaved.first

                if language == "EN" && en != nil
                {
                    return en!
                }
                else if language == "FR" && fr != nil
                {
                    return fr!
                }
                else if language == "ES" && es != nil
                {
                    return es!
                }
                else if language == "IT" && it != nil
                {
                    return it!
                }
                else if language == "DE" && de != nil
                {
                    return de!
                }
                else if language == "NL" && nl != nil
                {
                    return nl!
                }
                else if language == "PT" && pt != nil
                {
                    return pt!
                }



        }

        return nil
    }




    public static func getDistanceMeasurementSystem() -> UInt {

        //        let locale = Locale.current
        //               if (locale.languageCode == "fr" )
        //               {
        //                return .metric
        //               }
        //               else
        //               {
        //                return .imperial
        //               }

        return 0
    }

    public static func getLanguageAndCountry() -> String {

        let locale = Locale.current.languageCode?.uppercased()

               if (locale == "FR" )
               {
                   return "fr-FR"
               }
               else  if (locale == "EN" )
               {
                   return "en-US"
               }
               else  if (locale == "IT" )
               {
                   return "it-IT"
               }
               else  if (locale == "ES" )
               {
                   return "es-ES"
               }
               else  if (locale == "DE" )
               {
                   return "de-DE"
               }
               else  if (locale == "NL" )
               {
                   return "nl-NL"
               }
               else  if (locale == "PT" )
               {
                   return "pt-PT"
               }
               else
               {
                   return "en-US"
               }

    }


    public static func getLanguageAndCountry(language:String) -> String {

        let locale = language
        if (locale == "FR" )
        {
            return "fr-FR"
        }
        else  if (locale == "EN" )
        {
            return "en-US"
        }
        else  if (locale == "IT" )
        {
            return "it-IT"
        }
        else  if (locale == "ES" )
        {
            return "es-ES"
        }
        else  if (locale == "DE" )
        {
            return "de-DE"
        }
        else  if (locale == "NL" )
        {
            return "nl-NL"
        }
        else  if (locale == "PT" )
        {
            return "pt-PT"
        }
        else
        {
            return "en-US"
        }

    }


    public static func changeBeginningOfSmartRunWithnearestPoint( _ myTablePointGPX: Array<CLLocationCoordinate2D>, positionGPS: CLLocation!) -> Array<CLLocationCoordinate2D>{
        guard positionGPS != nil else {
            return myTablePointGPX
        }
        let nearestPointGPX = MyUtils.findNearestGPXPoint(myTablePointGPX, positionGPS: positionGPS)
        var newTablePointGPX: Array<CLLocationCoordinate2D> = []
        for j in nearestPointGPX ..< myTablePointGPX.count {
            newTablePointGPX.append(myTablePointGPX[j])
        }
        for k in 0 ..< nearestPointGPX {
            newTablePointGPX.append(myTablePointGPX[k])
        }
        return newTablePointGPX
    }

    public static func findNearestGPXPoint(_ myTablePointGPX: Array<CLLocationCoordinate2D>, positionGPS: CLLocation) -> Int{
        var nearestPointGPX:    Int                 = 0
        var deltaComparaison:   CLLocationDistance  = positionGPS.distance(from: CLLocation.init(latitude: myTablePointGPX[0].latitude, longitude: myTablePointGPX[0].longitude) )
        for i in 0 ..< myTablePointGPX.count {
            let delta: CLLocationDistance = positionGPS.distance(from:CLLocation.init(latitude: myTablePointGPX[i].latitude, longitude: myTablePointGPX[i].longitude))
            if delta < deltaComparaison{
                deltaComparaison    = delta
                nearestPointGPX     = i
            }
        }
        return nearestPointGPX
    }


    public static func checkNearestGPXPoint(_ myLocation: CLLocation, inArrayGPS : Array<CLLocationCoordinate2D>?) -> CLLocation? {
        guard inArrayGPS != nil else {
            return nil
        }

        var closestPoint: CLLocation!
        var tempMinimumDelta:CLLocationDistance = 40
        //We check if the user is next to a GPX Position
        for coordGPX in inArrayGPS! {
            let delta: CLLocationDistance = myLocation.distance(from: CLLocation.init(latitude: coordGPX.latitude, longitude: coordGPX.longitude))
            if delta < 40 && delta < tempMinimumDelta {
                tempMinimumDelta = delta
                //The user is next to a GPX Position
                //We save this position
                closestPoint = CLLocation.init(latitude: coordGPX.latitude, longitude: coordGPX.longitude)
            }
        }

        return closestPoint

    }


    public static func generateGpxTags(coordinatesArray: Array<CLLocationCoordinate2D>) -> Void {

        var tagsGpx = ""
        for (index, poi) in coordinatesArray.enumerated()
        {
            let time =  index * 1


            let secondes = time % 60
            let mintues = time / 60
            let tag = "<wpt lat='\(poi.latitude)' lon='\(poi.longitude)'>\n<name>Rue dugesclien/villeroy</name>\n<time>2014-09-24T14:\(mintues):\(secondes)Z</time>\n</wpt>"
            tagsGpx = "\(tagsGpx)\n\(tag)"
        }

        print(tagsGpx)


    }

    public static func generateBackGpxTags(coordinatesArray: Array<CLLocationCoordinate2D>) -> Void {

        var tagsGpx = ""
        for (index, poi) in coordinatesArray.reversed().enumerated()
        {
            let time =  index * 4


            let secondes = time % 60
            let mintues = time / 60
            let tag = "<wpt lat='\(poi.latitude)' lon='\(poi.longitude)'>\n<name>Rue dugesclien/villeroy</name>\n<time>2014-09-24T14:\(mintues):\(secondes)Z</time>\n</wpt>"
            tagsGpx = "\(tagsGpx)\n\(tag)"
        }

        print(tagsGpx)


    }
}


public class ProjectionUtils {
    //When projecting B into OA to create the point H
    public var isOnPlot: Bool
    public var coordinates : CLLocation! //are coordinates H
    public var parentCoordinatesInNewReference : CLLocation! //are coordinates B in new reference
    public var description : String { return "projection coord : " + self.coordinates.description + "coord in new reference : " + self.parentCoordinatesInNewReference.description }

    public init(){
        isOnPlot = false
        coordinates = nil
        parentCoordinatesInNewReference = nil
    }
}
