//
//  Style.swift
//  NavigationUI
//
//  Created by Hassine on 17/06/2020.
//  Copyright © 2020 com.mile. All rights reserved.
//

import Foundation
import UIKit

public class Style: StyleProtocol {
    
    public var title4Font: UIFont?



    public var grayColor: UIColor

    
    public var distanceInstructionFont: UIFont?

    public var primaryInstructionFont: UIFont?


    public var slideDotBorderColor: UIColor


    public var slideBackgroundColor: UIColor

    public var slideDotColor: UIColor


    public var textCardColor: UIColor


    public var timerCardColor: UIColor


    
    public var greenColor: UIColor
    
    public var redColor: UIColor
    

    public var backgroundColor: UIColor
    
    public var grayBackgroundColor: UIColor
    
    public var primaryColor: UIColor
    
    public var primaryColorDisabled: UIColor
    
    public var accentColor: UIColor
    
    public var titleColor: UIColor
    
    public var textBodyColor: UIColor
    
    public var textBodyAccentColor: UIColor
    
    public var cardColor: UIColor
    
    public var cardShadowColor: UIColor
    
    public var progressTintColor: UIColor
    
    public var progressBackColor: UIColor
    
    public var headerFont: UIFont?
    
    public var title1Font: UIFont?
    
    public var title2Font: UIFont?
    
    public var title3Font: UIFont?
    
    public var bodyFont: UIFont?
    
    public var bodyMediumFont: UIFont?
    
    public var normalFont: UIFont?
    
    public var captionFont: UIFont?
    
    public var btnPrimaryFont: UIFont?
    
    public var btnSecondaryFont: UIFont?
    
    public var btnTertiaryFont: UIFont?
    
    public var btnFloatFont: UIFont?
    
    public var btnFont: UIFont?

    public var timerCardFont: UIFont?

    public var valuesCardFont: UIFont?

    public var titleCardFont: UIFont?
    
    public var btnCornerRaduis: CGFloat


    
    public static let shared = Style()
    
    init() {
        if #available(iOS 11.0, *) {
            backgroundColor = UIColor.init(named: "BackgroundColor") ?? UIColor.white
        } else {
            backgroundColor = UIColor.white
        }
        
        grayBackgroundColor  = UIColor(red:0.96, green:0.96, blue:0.96, alpha:1.0) // F5F5F5
        
        primaryColor         = UIColor(red:0.00, green:0.25, blue:0.43, alpha:1.0) // 003F6D
        
        primaryColorDisabled = UIColor(red:0.00, green:0.25, blue:0.43, alpha:0.4)
        
        accentColor          = UIColor(red:0.07, green:0.15, blue:0.23, alpha:1.00) // 12263B
        
        titleColor           = UIColor(red:0.21, green:0.25, blue:0.30, alpha:1.0) // 35414C
        
        textBodyColor        = UIColor(red:0.37, green:0.42, blue:0.47, alpha:1.0) // 5f6c78
        
        textBodyAccentColor  = UIColor(red:0.07, green:0.15, blue:0.23, alpha:0.6) // 12263B
        
        cardColor            = UIColor(red:0.14, green:0.16, blue:0.22, alpha:1.0) // 3B414F
        
        cardShadowColor      = UIColor(red:0.14, green:0.15, blue:0.20, alpha:1.0) // 242633
        
        progressTintColor    = UIColor(red:0.80, green:0.80, blue:0.80, alpha:1.0) // CBCBCB
        
        progressBackColor    = UIColor(red:0.96, green:0.96, blue:0.96, alpha:1.0) // F6F6F6
        
        greenColor           = UIColor(red:0.15, green:0.68, blue:0.38, alpha:1.0) // 27AE60
        
        redColor             = UIColor(red:0.75, green:0.22, blue:0.17, alpha:1.0) //

        timerCardColor  =  UIColor(red:0.95, green:0.35, blue:0.32, alpha:1.00); // F25A51

        textCardColor  = UIColor(red:0.12, green:0.12, blue:0.12, alpha:1.00); // #1E1E1E

        slideBackgroundColor  = UIColor(red:0.12, green:0.12, blue:0.12, alpha:1.00); // #1E1E1E

        slideDotColor  = UIColor(red:0.12, green:0.12, blue:0.12, alpha:1.00); // #1E1E1E

        slideDotBorderColor  = UIColor(red:0.12, green:0.12, blue:0.12, alpha:1.00); // #1E1E1E
        
        headerFont = UIFont(name: "GothamRounded-Medium", size: 30)
        
        title1Font = UIFont(name: "GothamRounded-Medium", size: 18)
        
        title2Font = UIFont(name: "GothamRounded-Bold", size: 16)
        
        title3Font = UIFont(name: "GothamRounded-Bold", size: 14)
        
        bodyFont = UIFont(name: "GothamRounded-Book", size: 14)
        
        bodyMediumFont = UIFont(name: "GothamRounded-Medium", size: 14)
        
        normalFont = UIFont(name: "GothamRounded", size: 14)
        
        captionFont = UIFont(name: "GothamRounded-Bold", size: 12)
        
        btnPrimaryFont = UIFont(name: "GothamRounded", size: 16)
        
        btnSecondaryFont = UIFont(name: "GothamRounded", size: 16)
        
        btnTertiaryFont = UIFont(name: "GothamRounded", size: 12)

        timerCardFont = UIFont(name: "GothamRounded-Medium", size: 30)

        valuesCardFont = UIFont(name: "GothamRounded", size: 16)

        titleCardFont = UIFont(name: "GothamRounded", size: 16)
        
        btnFloatFont = UIFont(name: "GothamRounded-Medium", size: 22)
        
        btnFont = UIFont(name: "GothamRounded-Bold", size: 14)

        distanceInstructionFont = UIFont(name: "GothamRounded-Book", size: 45)

        primaryInstructionFont = UIFont(name: "GothamRounded-Book", size: 28)
        
        btnCornerRaduis = 30

        grayColor = UIColor(red:0.44, green:0.49, blue:0.54, alpha:1.00)
    }
}



public protocol StyleProtocol {
    
    // Backgrounds
    var backgroundColor      :  UIColor  { get set }
    var grayBackgroundColor  :  UIColor  { get set }
    // Colors
    var primaryColor         :  UIColor  { get set }
    var primaryColorDisabled :  UIColor  { get set }
    var accentColor          :  UIColor  { get set }
    
    var greenColor           :  UIColor  { get set }
    var redColor             :  UIColor  { get set }
    var grayColor            :  UIColor  { get set }

    var slideBackgroundColor :  UIColor  { get set }
    var slideDotColor        :  UIColor  { get set }
    var slideDotBorderColor  :  UIColor  { get set }
    
    
    // Text
    var titleColor           :  UIColor  { get set }
    var textBodyColor        :  UIColor  { get set }
    var textBodyAccentColor  :  UIColor  { get set }
    var timerCardColor       :  UIColor  { get set }
    var textCardColor        :  UIColor  { get set }
    // Cards
    var cardColor            :  UIColor  { get set }
    var cardShadowColor      :  UIColor  { get set }
    // Progress
    var progressTintColor    :  UIColor  { get set }
    var progressBackColor    :  UIColor  { get set }
    
    // Fonts
    var headerFont           :  UIFont?  { get set }
    var title1Font           :  UIFont?  { get set }
    var title2Font           :  UIFont?  { get set }
    var title3Font           :  UIFont?  { get set }
    var title4Font           :  UIFont?  { get set }
    var bodyFont             :  UIFont?  { get set }
    var bodyMediumFont       :  UIFont?  { get set }
    var normalFont           :  UIFont?  { get set }
    var captionFont          :  UIFont?  { get set }
    var timerCardFont        :  UIFont?  { get set }
    var valuesCardFont       :  UIFont?  { get set }
    var titleCardFont        :  UIFont?  { get set }
    var distanceInstructionFont        :  UIFont?  { get set }
    var primaryInstructionFont        :  UIFont?  { get set }
    
    var btnPrimaryFont       :  UIFont?  { get set }
    var btnSecondaryFont     :  UIFont?  { get set }
    var btnTertiaryFont      :  UIFont?  { get set }
    var btnFloatFont         :  UIFont?  { get set }
    var btnFont              :  UIFont?  { get set }
    var btnCornerRaduis      :  CGFloat  { get set }
    
    
}


