import Flutter
import UIKit
import MapboxDirections
import MapboxCoreNavigation
import MapboxNavigation

public class SwiftMileNavigationEnginePlugin: NSObject, FlutterPlugin {
  var _navigationViewController: NavigationViewController? = nil

      var _distanceRemaining: Double?
      var _durationRemaining: Double?
      var _navigationMode: String?


    public static func register(with registrar: FlutterPluginRegistrar) {
        let instance = MileNavigationEngineFactory(withRegistrar: registrar)
        registrar.register(instance, withId: "navigation_view")
    }


    func convertToDictionary(text: String) -> [String: Any]? {
        if let data = text.data(using: .utf8) {
            do {
                return try JSONSerialization.jsonObject(with: data, options: []) as? [String: Any]
            } catch {
                print(error.localizedDescription)
            }
        }
        return nil
    }
}
