//
//  City.swift
//  NavigationUI
//
//  Created by Hassine on 17/06/2020.
//  Copyright © 2020 com.mile. All rights reserved.
//
import CoreLocation


public struct City   {

    public var icon_code: Int = 0

    public var units: String = ""

    public var countryId: String?

    

    public var tempvalue: Double = 0.0

    
    public var key: String
    //var ref: DatabaseReference?
    
    public  var name: String {
        get {

            return MyUtils.translateToSelectedLanguage(en: nameEn, fr: nameFr, es: nameEs, it: nameIt, de: nameDe, nl: nameNl, pt: namePt)
        }
    }
    public  var temperature: String {
        return temperatureC ?? "0"
    }
    public var imageURL: URL?
    public var spotifyURL: String?
    public var coordinate: CLLocationCoordinate2D?
    public var routesID: [String] = []
    public var routes: [RouteInformation] = []
    public var distance: Double = 0.0

    private var nameFr: String?
    private var nameEn: String?
    private var nameEs: String?
    private var nameDe: String?
    private var nameIt: String?
    private var nameNl: String?
    private var namePt: String?

    private var temperatureC: String?
    private var temperatureF: String?



    init(snapshotValue: [String:Any],key:String) {

        //ref = nil
        self.key = key

        if let nameDictionary = snapshotValue["Name"] as? NSMutableDictionary
        {
             nameEn = nameDictionary["EN"] as? String ?? nil
                      nameFr = nameDictionary["FR"] as? String ?? nil
                      nameIt = nameDictionary["IT"] as? String ?? nil
                      nameEs = nameDictionary["ES"] as? String ?? nil
                      nameDe = nameDictionary["DE"] as? String ?? nil
                      nameNl = nameDictionary["NL"] as? String ?? nil
                      namePt = nameDictionary["PT"] as? String ?? nil
        }

        if let temperatureDictionary = snapshotValue["temperature"] as? NSMutableDictionary
        {
            temperatureC = temperatureDictionary["value"] as? String
        }

        if let temperatureDictionary = snapshotValue["temperatureFahrenheit"] as? NSMutableDictionary
        {
            temperatureF = temperatureDictionary["value"] as? String
        }

        spotifyURL = snapshotValue["SpotifyUrl"] as? String
        if let url = snapshotValue["ImageUrl"] as? String
        {
            imageURL = URL.init(string: url) ?? nil
        }

        if let coordinatesDictionary = snapshotValue["Coordinates"] as? NSMutableDictionary
        {

            let longitude = coordinatesDictionary["Longitude"] as? Double
            let latitude = coordinatesDictionary["Latitude"] as? Double
            if longitude != nil && latitude != nil
            {
                coordinate = CLLocationCoordinate2D.init(latitude: latitude!, longitude: longitude!)
            }

        }


        if let weatherDictionary = snapshotValue["Weather"] as? NSMutableDictionary
        {

            icon_code = weatherDictionary["icon_code"] as? Int ?? 0
            if let temperature = weatherDictionary["temperature"] as? NSMutableDictionary
            {
                 units = temperature["units"] as? String ?? ""
                tempvalue = temperature["value"] as? Double ?? 0.0
            }


        }

        if let countryDictionary = snapshotValue["Country"] as? NSMutableArray
        {
            countryId = countryDictionary[0] as? String
        }

        

        if let routes = snapshotValue["Routes"] as? [String]
        {
            routesID = routes
        }
    }

    
    
    
    init() {
        key = ""
        temperatureC = ""
        nameFr = ""
        nameEn = ""
        imageURL = nil
        coordinate = nil
        //ref = nil
    }
    

}




