//
//  CustomVoiceController.swift
//  NavigationUIExemple
//
//  Created by Hassine on 17/06/2020.
//  Copyright © 2020 com.mile. All rights reserved.
//

import UIKit
import MapboxSpeech
import Mapbox
import AVFoundation
import MapboxSpeech
import MapboxCoreNavigation
import MapboxDirections
import MapboxNavigation

/// MapboxVoiceController 82

//@objc public func audioPlayerDidFinishPlaying(_ player: AVAudioPlayer, successfully flag: Bool) {
//    do {
//        try unDuckAudio()
//         NotificationCenter.default.post(name:NSNotification.Name("finishAudio"),object: nil)
//        print("finishAudio")
//    } catch {
//        voiceControllerDelegate?.voiceController?(self, spokenInstructionsDidFailWith: error)
//    }
//
//}



class CustomVoiceController: MapboxVoiceController {
    
    override func audioPlayerDidFinishPlaying(_ player: AVAudioPlayer, successfully flag: Bool) {
        super.audioPlayerDidFinishPlaying(player, successfully: flag)
        NotificationCenter.default.post(name:NSNotification.Name("finishAudio"),object: nil)
    }
    
    override func didPassSpokenInstructionPoint(notification: NSNotification) {
        print(notification)
        super.didPassSpokenInstructionPoint(notification: notification)
        let routeProgress = notification.userInfo![RouteController.NotificationUserInfoKey.routeProgressKey] as! RouteProgress
        print(routeProgress.currentLegProgress.currentStep.maneuverType)
        //        let soundForInstruction = audio(for: routeProgress.currentLegProgress.currentStep)
        let instruction = notification.userInfo![RouteController.NotificationUserInfoKey.spokenInstructionKey] as! SpokenInstruction
        //        play(instruction: instruction, data: soundForInstruction)
        
        if routeProgress.currentLegProgress.currentStep.maneuverType == .depart
        {
            if  let steps = routeProgress.currentLegProgress.currentStep.instructionsSpokenAlongStep
            {
                if steps.count > 1
                {
                    //  play(instruction: instruction, data: soundForInstruction)
                }
            }
        }
        
        
    }
    
    override func speak(_ instruction: SpokenInstruction) {
        super.speak(instruction)
    }
    
    func initNotification()
    {
        NotificationCenter.default.addObserver(self,selector: #selector(playerDidFinishPlaying),name: NSNotification.Name ("finishAudio"),object: nil)
    }
    
//    func playDirectionnal(_ data: Data) -> Void {
//        guard !NavigationSettings.shared.voiceMuted else { return }
//        if (  PlayerManager.shared.speechSynthesizer.isSpeaking )
//        {
//            PlayerManager.shared.speechSynthesizer.pauseSpeaking(at: AVSpeechBoundary.immediate)
//        }
//        super.play(data)
//    }
    
    func stopPlayer() -> Void
    {
        self.audioPlayer?.stop()
    }


    override func play(instruction: SpokenInstruction, data: Data) {

        if (MyNavigationView.mutedZone == false)
        {

            if !instruction.text.contains("you will arrive at your 1st destination") && !instruction.text.contains("vous arriverez à votre première destination") && !instruction.text.contains("as a llegar a tu 1ª destino ")  && !instruction.text.contains("poi sei arrivato alla tua 1ª destinazione") && !instruction.text.contains("poi sei arrivato alla tua 1ª destinazione") && !instruction.text.contains("está a chegar ao seu 1º destino") && !instruction.text.contains("erstes Ziel erreicht") && !instruction.text.contains("erstes Ziel")
            {
                  if (  PlayerManager.shared.speechSynthesizer.isSpeaking )
                          {
                             PlayerManager.shared.speechSynthesizer.pauseSpeaking(at: AVSpeechBoundary.immediate)
                                                          super.play(instruction: instruction, data: data)
                          }
                else
                  {
                     super.play(instruction: instruction, data: data)
                }
            }
            else
            {
                print(instruction.text)
            }
        }
        else
        {
            print("muted zone")
        }
    }
    
    
    @objc func playerDidFinishPlaying() {
        if let player = self.audioPlayer
        {
            if !player.isPlaying
            {
                if PlayerManager.shared.speechSynthesizer.isPaused{
                    PlayerManager.shared.speechSynthesizer.continueSpeaking()
                }
            }
        }
    }
}


