//
//  LanguageRessource.swift
//  NavigationUI
//
//  Created by Hassine on 03/06/2020.
//  Copyright © 2020 com.mile. All rights reserved.
//

import Foundation


class LanguageRessource {
    
    var reRouting: String
    var endRoute: String
    var inversionRoute: String
    var routeReached: String
    var routeReachedAgain: String
    var startNavigationToRoute: String
    var startNavigationToStaticStartingPoint: String
    var wrongWay: String
    var resumeNavigation: String
    var pauseNavigation: String
    var toYourRight: String
    var toYourLeft: String
    var inFront: String
    var right : String
    var left : String
    var continueStraight : String
    var continueStraightFor : String
    var uTurn : String
    var now: String
    var moreInfo: String
    var lowBattery : String
    var turnLeft: String
    var turnRight: String
    var then: String
    var onto : String
    var toCrossTheRoad: String
    var annonceSponsor: String
    var andSponsor : String
    var moreSponsorInformations: String
    var FIRSTSMARTFACT: String

    enum Direction{
        case right
        case left
        case carryOn
        case none
    }

    init(languageSelected: String) {


        switch languageSelected {
        case "French":
            reRouting = "Vous quittez le Smart Run. Merci de revenir sur vos pas.";
            endRoute =  "Félicitations, vous avez fini votre parcours ! N'hésitez pas à nous donner votre avis.";
            inversionRoute = "Nous venons de modifier l'orientation du Smart Run.";
            routeReached =  "Vous avez atteint le Smart Run. Continuez tout droit.";
            routeReachedAgain = "Vous êtes sur le Smart Run.";
            startNavigationToRoute = "Nous allons maintenant vous guider à pied vers le point le plus proche du parcours.";
            startNavigationToStaticStartingPoint = "Nous allons maintenant vous guider à pied vers le point de départ du parcours."
            //"Afin de vous offrir la meilleure expérience possible, nous devons vous faire démarrer ce parcours à un endroit précis de la ville. Laissez-vous guider à pied dès maintenant.";
            wrongWay = "Vous courez dans le mauvais sens, faite demi tour."
            resumeNavigation = "Reprise du parcours";
            pauseNavigation = "Parcours en pause";
            toYourRight = "À votre droite, ";
            toYourLeft = "À votre gauche, ";
            right = "droite";
            left = "gauche";
            inFront = "Face à vous, ";
            continueStraight =  "continuez tout droit ";
            continueStraightFor = "continuez tout droit sur %@ mètres";
            uTurn = "Faites demi-tour ";
            now = "maintenant";
            moreInfo = "+ d'infos";
            lowBattery = "Attention, votre batterie est à 10 pourcents";
            turnRight = "Tournez à droite ";
            turnLeft = "Tournez à gauche ";
            toCrossTheRoad = "pour traverser la route,";
            then = " puis "; //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
            onto = " sur ";
            annonceSponsor = "Ce parcours vous est offert par ";
            andSponsor = ", et, ";
            moreSponsorInformations = ". Pour plus d'informations, cliquez sur les marqueurs rouges.";
            FIRSTSMARTFACT = "Le saviez-vous ? Une bouteille en plastique jetée dans la nature peut mettre jusqu’à mille ans pour se dégrader. Et ce n’est qu’un exemple ! Si vous souhaitez en faire plus pour la planète, n’hésitez pas à ramasser et jeter quelques-uns des déchets que vous croiserez sur votre parcours, la planète vous remerciera !";
        case "English":
            reRouting = "You just left the Smart Run, please turn back.";
            endRoute = "Congratulations, you have reached the end of this Smart Run! Please feel free to give us a feedback.";
            inversionRoute = "We have changed the direction of the Smart Run";
            routeReached = "You have reached the Smart Run, please carry straight on.";
            routeReachedAgain = "You are on the Smart Run";
            startNavigationToRoute = "We will now guide you to the Smart Run.";
            startNavigationToStaticStartingPoint = "In order to offer you the best experience possible, we will direct you to a specific point in the city from which the route will begin. Relax and let the GPS guide you to the start point.";
            wrongWay = "You are running the wrong way, please make a u-turn."
            resumeNavigation = "Smart Run resumed";
            pauseNavigation = "Smart Run paused";
            toYourRight = "To your right, ";
            toYourLeft = "To your left, ";
            right = "right";
            left = "left";
            inFront = "Straight ahead, ";
            continueStraight =  "carry straight on ";
            continueStraightFor = "carry straight on for %@ meters";
            uTurn = "Make a u-turn ";
            now = "now";
            moreInfo = "More info";
            lowBattery = "Warning, battery level at 10 percent";
            then = " then "; //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
            onto = " onto ";
            turnRight = "Turn right"; //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
            turnLeft = "Turn left"; //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
            toCrossTheRoad = "to cross the road,";
            annonceSponsor = "This Smart Run is brought to you by ";
            andSponsor = ", and, ";
            moreSponsorInformations = ". For more information, click on the red pin.";
            FIRSTSMARTFACT = "Did you know? A plastic bottle can take up to 1000 years to fully biodegrade… and that’s just one example! If you want to help protect the planet, why not pick up some litter during your run? The planet would be very grateful!";
        case "Dutch":
            reRouting = "Je verlaat de Smart Run. Gelieve terug te keren.";
            endRoute = "Proficiat, je hebt het einde van de Smart Run bereikt ! Bezorg ons je feedback.";
            inversionRoute = "We hebben de richting van de Smart Run gewijzigd.";
            routeReached = "Je hebt de Smart Run bereikt. Ga rechtdoor.";
            routeReachedAgain = "Je hebt de Smart Run bereikt.";
            startNavigationToRoute = "We zullen je nu naar de Smart Run leiden.";
            startNavigationToStaticStartingPoint =  startNavigationToRoute;
            wrongWay = "Je loopt in de verkeerde richting, gelieve terug te keren.";
            resumeNavigation = "Hervatten van de Smart Run";
            pauseNavigation = "Smart Run gepauzeerd";
            toYourRight = "Op je rechterkant, ";
            toYourLeft = "Op je linkerkant, ";
            right = "rechts";
            left = "links";
            inFront = "Voor je, ";
            continueStraight = "Draag rechtdoor ";
            continueStraightFor = "Draag rechtdoor voor %@ meter";
            uTurn = "Maak een U-bocht ";
            now = "nu";
            moreInfo = "Meer informatie";
            lowBattery = "Waarschuwing, batterijniveau op 10 procent" //GOOGLE TRAD
            toCrossTheRoad = "om de straat over te steken,";
            then = " vervolgens "; //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
            onto = " naar ";
            turnLeft = "Links afslaan"; //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
            turnRight = "Rechts afslaan"; //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
            annonceSponsor = "Deze Smart Run wordt aangeboden door "; //GOOGLE TRAD
            andSponsor = ", en, "; //GOOGLE TRAD
            moreSponsorInformations = ". Klik voor meer informatie op de rode markeringen."; //GOOGLE TRAD
            FIRSTSMARTFACT = "Wist je dat? Het kan 1000 jaar duren voordat een plastic fles volledig biologisch is afgebroken ... en dat is slechts een voorbeeld! Als je wilt helpen de planeet te beschermen, waarom dan niet wat zwerfvuil oprapen tijdens je run? De planeet zou erg dankbaar zijn!";
        case "Spanish":
            reRouting = "Estás abandonando el Smart Run.Por favor da marcha atrás.";
            endRoute =  "Felicitaciones,¡Has terminado tu Smart Run!No dudes en darnos tu opinión.";
            inversionRoute = "Acabamos de modificar la orientación del Smart Run.";
            routeReached = "Has llegado al Smart Run. Sigue recto.";
            routeReachedAgain = "Estás en el Smart Run.";
            startNavigationToRoute = "Ahora vamos a guiarte a pie hasta el punto más cercano del Smart Run.";
            startNavigationToStaticStartingPoint = "Para ofrecerte la mejor experiencia posible, este recorrido empieza en un lugar concreto de la ciudad. Déjate guiar a pie hasta el punto de partida.";
            wrongWay = "Estás corriendo en el sentido contrario, da media vuelta."
            resumeNavigation = "Reanudación del Smart Run";
            pauseNavigation = "Smart Run en pausa";
            toYourRight = "A tu derecha, ";
            toYourLeft = "A tu izquierda, ";
            right = "derecha";
            left = "izquierda";
            inFront = "Frente a ti, ";
            continueStraight =  "sigue recto ";
            continueStraightFor = "sigue recto sobre %@ metros ";
            uTurn = "Da media vuelta ";
            now = "ahora";
            moreInfo = "+ informaciones";
            lowBattery = "Cuidado,tienes 10 por ciento de batería";
            turnRight = "Gira a la derecha ";
            turnLeft = "Gira a la izquierda ";
            toCrossTheRoad = "para atravesar la ruta,";
            then = " luego ";
            onto = " sobre ";
            annonceSponsor = "Este Smart Run es ofrecido por ";
            andSponsor = ", y, ";
            moreSponsorInformations = ". Para más información, haz clic en los marcadores rojos.";
            FIRSTSMARTFACT = "¿Sabías que una botella de plástico desechada en la naturaleza puede tardar hasta mil años en descomponerse? ¡Y no es más que un ejemplo! Si quieres ayudar a cambiar las cosas, no dudes en recoger y tirar los residuos que te encuentres por el camino. ¡El planeta te lo agradecerá!";
        case "Italian":
            reRouting = "Stai abbandonando lo Smart Run. Torna indietro.";
            endRoute =  "Complimenti, hai terminato il tuo Smart Run! Dicci cosa ne pensi.";
            inversionRoute = "La direzione dello Smart Run è stata appena modificata.";
            routeReached =  "Hai raggiunto lo Smart Run. Continua dritto.";
            routeReachedAgain = "Sei sullo Smart Run.";
            startNavigationToRoute = "Adesso, sarai guidato verso lo Smart Run.";
            startNavigationToStaticStartingPoint =  "Per offrirti la migliore esperienza possibile, è necessario cominciare il percorso da un punto preciso della città. Lasciati guidare a piedi dal GPS fino al punto di partenza.";
            wrongWay = "Stai correndo nella direzione sbagliata, torna indietro."
            resumeNavigation = "Ripresa dello Smart Run";
            pauseNavigation = "Lo Smart Run è in pausa";
            toYourRight = "Alla tua destra, ";
            toYourLeft = "Alla tua sinistra, ";
            right = "destra";
            left = "sinistra";
            inFront = "Di fronte a te, ";
            continueStraight =  "continua dritto ";
            continueStraightFor = "continua dritto su %@ metri";
            uTurn = "torna indietro ";
            now = "adesso";
            moreInfo = "maggiori informazioni";
            lowBattery = "Attenzione, la batteria è al 10 percento";
            turnRight = "Gira a destra ";
            turnLeft = "Gira a sinistra ";
            toCrossTheRoad = "per attraversare la strada,";
            then = " poi "; //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
            onto = " su ";
            annonceSponsor = "Questo Smart Run è offerto da ";
            andSponsor = ", e, ";
            moreSponsorInformations = ". Per maggiori informazioni, clicca sui contrassegni rossi.";
            FIRSTSMARTFACT = "Lo sai che? Una bottiglia di plastica può metterci fino a 1000 anni per decomporsi?E questo non è che un esempio! Se desideri fare di più per il nostro pianeta Terra, raccogli e getta dei rifiuti mentre corri. La Terra ti ringrazierà!";
        case "German":
            reRouting = "Sie verlassen den Smart Run. Bitte kehren Sie um.";
            endRoute =  "Gratulation, Sie haben Ihren Smart Run beendet! Teilen Sie uns gerne Ihre Meinung mit.";
            inversionRoute = "Wir haben soeben die Richtung des Smart Runs geändert.";
            routeReached =  "Sie haben den Smart Run erreicht. Laufen Sie geradeaus weiter.";
            routeReachedAgain = "Sie befinden sich auf dem Smart Run.";
            startNavigationToRoute = "Wir führen Sie nun zu Fuß zum nächstgelegenen Punkt des Smart Runs.";
            startNavigationToStaticStartingPoint =  startNavigationToRoute;
            wrongWay = "Sie laufen in die falsche Richtung. Kehren Sie."
            resumeNavigation = "Wiederaufnahme des Smart Runs";
            pauseNavigation = "Smart Run angehalten";
            toYourRight = "Zu Ihrer Rechten, ";
            toYourLeft = "Zu Ihrer Linken, ";
            right = "rechts";
            left = "links";
            inFront = "Ihnen gegenüber, ";
            continueStraight =  "geradeaus weiterlaufen";
            continueStraightFor = "Laufen Sie %@ Meter geradeaus weiter";
            uTurn = "Drehen Sie um";
            now = "jetzt";
            moreInfo = "mehr Infos";
            lowBattery = "Achtung, Ihr Akku hat nur noch 10 Prozent";
            turnRight = "Biegen Sie nach rechts ab";
            turnLeft = "Biegen Sie nach links ab";
            toCrossTheRoad = "um die Straße zu überqueren,";
            then = " dann "; //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
            onto = " auf ";
            annonceSponsor = "Dieser Smart Run wird Ihnen angeboten von ";
            andSponsor = ", und, ";
            moreSponsorInformations = ". Für weitere Informationen tippen Sie auf die roten Stecknadeln.";
            FIRSTSMARTFACT = "Schon gewusst? Eine Plastikflasche kann bis zu tausend Jahre dauern, bis sie sich in der Natur zersetzt hat. Und das ist nur ein Beispiel! Wenn Sie der Umwelt helfen wollen, sammeln Sie auf ihrem Weg Müll ein und entsorgen Sie es. Der Planet wird  Ihnen dafür sehr dankbar sein!";
        default:  reRouting = "You just left the Smart Run, please turn back.";
                   endRoute = "Congratulations, you have reached the end of this Smart Run! Please feel free to give us a feedback.";
                   inversionRoute = "We have changed the direction of the Smart Run";
                   routeReached = "You have reached the Smart Run, please carry straight on.";
                   routeReachedAgain = "You are on the Smart Run";
                   startNavigationToRoute = "We will now guide you to the Smart Run.";
                   startNavigationToStaticStartingPoint = "In order to offer you the best experience possible, we will direct you to a specific point in the city from which the route will begin. Relax and let the GPS guide you to the start point.";
                   wrongWay = "You are running the wrong way, please make a u-turn."
                   resumeNavigation = "Smart Run resumed";
                   pauseNavigation = "Smart Run paused";
                   toYourRight = "To your right, ";
                   toYourLeft = "To your left, ";
                   right = "right";
                   left = "left";
                   inFront = "Straight ahead, ";
                   continueStraight =  "carry straight on ";
                   continueStraightFor = "carry straight on for %@ meters";
                   uTurn = "Make a u-turn ";
                   now = "now";
                   moreInfo = "More info";
                   lowBattery = "Warning, battery level at 10 percent";
                   then = " then "; //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
                   onto = " onto ";
                   turnRight = "Turn right"; //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
                   turnLeft = "Turn left"; //Must be the same word than combine instruction in SKMaps.bundle language file General_TTS
                   toCrossTheRoad = "to cross the road,";
                   annonceSponsor = "This Smart Run is brought to you by ";
                   andSponsor = ", and, ";
                   moreSponsorInformations = ". For more information, click on the red pin.";
                   FIRSTSMARTFACT = "Did you know? A plastic bottle can take up to 1000 years to fully biodegrade… and that’s just one example! If you want to help protect the planet, why not pick up some litter during your run? The planet would be very grateful!";

        }
    }

    func instructionOrientation(instruction : String) -> Direction{
        if instruction.contains(left) {
            return Direction.left
        }else if instruction.contains(right){
            return Direction.right
        }else{
            return Direction.none
        }
    }


}
