//
//  MyNavigationView+SlideButtonDelegate+MyPauseRunDelegate.swift
//  NavigationUI
//
//  Created by Hassine on 03/06/2020.
//  Copyright © 2020 com.mile. All rights reserved.
//

import Foundation
import LiquidFloatingActionButton


extension MyNavigationView : SlideButtonDelegate, MyPauseRunDelegate
{
    func manageVoice() {
        if isMuted
        {
            self.voiceController?.audioPlayer?.volume = 1
            PlayerManager.shared.audioPlayerPoiDescriptionQueue?.volume = 1
        }
        else
        {
            self.voiceController?.audioPlayer?.volume = 0
            PlayerManager.shared.audioPlayerPoiDescriptionQueue?.volume = 0
        }
        isMuted = !isMuted
    }
    
    func stopMyNavigation() {
        deinitNavigation()

        flutterOnNavigationFinished()

        var h = Historic.init()
        h.time = runTime_seconds
        
        if distanceTitle_lbl.text == "m"{
            h.distanceTravelled = Int((Double(distanceValue_lbl.text!.replacingOccurrences(of: ",", with: ".")) ?? 0 ) )
        } else {
            h.distanceTravelled = Int((Double(distanceValue_lbl.text!.replacingOccurrences(of: ",", with: ".")) ?? 0 ) * 1000)
        }
        
        //h.mediumSpeed = Double(speedValue_lbl.text!.replacingOccurrences(of: ",", with: ".")) ?? 0.0
        
        h.mediumSpeed = getMediumSpeed(distance:  h.distanceTravelled , timeInSecond: h.time)
        
        if let weight = Int(user?.weight ?? "") {
            h.calories = calculateCalorie(h.mediumSpeed, userWeight: weight, nbMinuteRanOnSR: Int(Double(h.time)/60))
        } else {
            h.calories = nil
        }
    }
    
    func calculateCalorie(_ userMediumSpeed_KmH: Double, userWeight: Int, nbMinuteRanOnSR:Int) -> Int {
        //Calcul via la formule disponible ici :
        // http://www.regivia.com/index.php/comment-maigrir-conseils-solutions-trucs-et-astuces/calcul-des-depenses-energetiques-en-calories-par-sports-et-activites/depenses-caloriques-consommees-pour-la-course-a-pied-le-running-footing-ou-jogging/
        
        //Loading user weight :
        var MET: Double = 6 //level of effort : define by the medium user speed
        if userMediumSpeed_KmH > 6 {
            MET = userMediumSpeed_KmH
        }else if userMediumSpeed_KmH < 1 {
            MET = 0
        }
        let burnedCalorie: Int = (Int(MET) * 3 * userWeight/200) * nbMinuteRanOnSR
        return burnedCalorie
    }
    
    
    
    func buttonStatus(status: String, sender: MMSlidingButton) {
        let router = MyNavigationRouter.init()
        let controller = router.createPauseController(whiteLabel: self.whiteLabel!, gpsColor: self.gpsColor)
        controller.delegate = self
        var historic = Historic.init()
        historic.time = runTime_seconds
        if distanceTitle_lbl.text == "m"
        {
            historic.distanceTravelled = Int((Double(distanceValue_lbl.text!.replacingOccurrences(of: ",", with: ".")) ?? 0 ) )
        }
        else
        {
            historic.distanceTravelled = Int((Double(distanceValue_lbl.text!.replacingOccurrences(of: ",", with: ".")) ?? 0 ) * 1000)
        }
        historic.mediumSpeed = getMediumSpeed(distance: historic.distanceTravelled, timeInSecond: historic.time)
        controller.historic = historic
        controller.isMuted = isMuted
        self.present(controller, animated: true) {
            self.pauseRun_slideBtn.reset()
        }
    }
    
    func checkBestLanguage() -> Void {
        if  let arraySaved = UserDefaults.standard.array(forKey: "languagePreferredOrder") as! Array<String>? {
            var poiTranslated = 0
            for language in arraySaved {
                if let pois = pois {
                    if pois.count == 0 {
                        languageAndCountry = MyUtils.getLanguageAndCountry(language: language)
                         return
                    }
                    for poi in pois {
                        if let desc = poi.getDescription(language: language) {
                            poiTranslated += 1
                        }
                    }
                    let percent = (poiTranslated / pois.count * 100)
                    if percent >= 70 {
                        languageAndCountry = MyUtils.getLanguageAndCountry(language: language)
                        return
                    }
                } else {
                    languageAndCountry = MyUtils.getLanguageAndCountry(language: language)
                     return
                }
                
            }
            
            languageAndCountry = MyUtils.getLanguageAndCountry(language: MyUtils.getLanguage())
             return
        } else {
            languageAndCountry = MyUtils.getLanguageAndCountry(language: MyUtils.getLanguage())
             return
        }
    }
    
    func getMediumSpeed(distance : Int, timeInSecond : Int) -> Double {
        //TODO check for Mile
        if timeInSecond != 0 {
            let speed  = Double(Double(distance)/1000) / Double(Double(timeInSecond)/3600)
            return speed
        }else{
            return 0
        }
    }
}
